#!/bin/sh
#/usr/bin/time g++ /home/mingo/dev/dadbiz++/third-party/dad/sqlite3-orig/sqlite3.c -fsyntax-only -I/home/mingo/dev/dadbiz++/third-party/dad/sqlite3-orig
#bd=/home/mingo/dev/dadbiz++/third-party/dad/sqlite3-orig
bd=.
srcfn=sqlite3.cpp
#srcfn=lexer.cc
CXX="./cxx -toolchain linux"
#CXX="gcc"
#CXX="g++ -fpermissive"
#CXX="clang-17-env clang++"
#CXX="clang++ -std=c++2a"
#cxxargs=-ast-dump
#cxxargs="-fsyntax-only"
cxxargs="-c"
cmd_wrapper="/usr/bin/time"
cmd_wrapper="/usr/bin/time myvalgrind --trace-children=yes"
#cmd_wrapper="clang-16-env /usr/bin/time"
cmd="$cmd_wrapper $CXX $bd/$srcfn $cxxargs -I$bd"
echo $cmd
$cmd #> /dev/null

exit 0

/usr/bin/time ./cxx -toolchain linux ./sqlite3.cpp -fsyntax-only -I.
1.01user 0.06system 0:01.08elapsed 99%CPU (0avgtext+0avgdata 146628maxresident)k
0inputs+0outputs (0major+39686minor)pagefaults 0swaps

/usr/bin/time g++ -fpermissive ./sqlite3.cpp -fsyntax-only -I.
1.08user 0.07system 0:01.16elapsed 99%CPU (0avgtext+0avgdata 115564maxresident)k
0inputs+0outputs (0major+29614minor)pagefaults 0swaps

/usr/bin/time myvalgrind ./cxx -toolchain linux ./sqlite3.cpp -fsyntax-only -I.
==21479==     in use at exit: 0 bytes in 0 blocks
==21479==   total heap usage: 3,003,109 allocs, 3,003,109 frees, 4,175,102,281 bytes allocated
55.95user 0.31system 0:56.27elapsed 99%CPU (0avgtext+0avgdata 408920maxresident)k
0inputs+0outputs (0major+127697minor)pagefaults 0swaps

/usr/bin/time myvalgrind --trace-children=yes g++ -fpermissive ./sqlite3.cpp -fsyntax-only -I.
==21623== Command: g++ -fpermissive ./sqlite3.cpp -fsyntax-only -I.
==21624==     in use at exit: 7,045,865 bytes in 15,051 blocks
==21624==   total heap usage: 490,444 allocs, 475,393 frees, 649,209,160 bytes allocated
==21624== Command: /usr/lib/gcc/x86_64-linux-gnu/9/cc1plus -quiet -I . -imultiarch x86_64-linux-gnu -D_GNU_SOURCE ./sqlite3.cpp -quiet -dumpbase sqlite3.cpp -mtune=generic -march=x86-64 -auxbase sqlite3 -fpermissive -fsyntax-only -o /dev/null -fasynchronous-unwind-tables -fstack-protector-strong -Wformat -Wformat-security
==21623==     in use at exit: 189,449 bytes in 69 blocks
==21623==   total heap usage: 234 allocs, 165 frees, 215,031 bytes allocated
40.27user 0.34system 0:40.63elapsed 99%CPU (0avgtext+0avgdata 337688maxresident)k
4416inputs+0outputs (1major+147633minor)pagefaults 0swaps

/usr/bin/time myvalgrind ./cxx -toolchain linux ./sqlite3.cpp -fsyntax-only -I.
==21479== Memcheck, a memory error detector
==21479== Copyright (C) 2002-2022, and GNU GPL'd, by Julian Seward et al.
==21479== Using Valgrind-3.21.0 and LibVEX; rerun with -h for copyright info
==21479== Command: ./cxx -toolchain linux ./sqlite3.cpp -fsyntax-only -I.
==21479==
==21479==
==21479== HEAP SUMMARY:
==21479==     in use at exit: 0 bytes in 0 blocks
==21479==   total heap usage: 3,003,109 allocs, 3,003,109 frees, 4,175,102,281 bytes allocated
==21479==
==21479== All heap blocks were freed -- no leaks are possible
==21479==
==21479== For lists of detected and suppressed errors, rerun with: -s
==21479== ERROR SUMMARY: 0 errors from 0 contexts (suppressed: 0 from 0)
55.95user 0.31system 0:56.27elapsed 99%CPU (0avgtext+0avgdata 408920maxresident)k
0inputs+0outputs (0major+127697minor)pagefaults 0swaps

/usr/bin/time myvalgrind --trace-children=yes g++ -fpermissive ./sqlite3.cpp -fsyntax-only -I.
==21623== Memcheck, a memory error detector
==21623== Copyright (C) 2002-2022, and GNU GPL'd, by Julian Seward et al.
==21623== Using Valgrind-3.21.0 and LibVEX; rerun with -h for copyright info
==21623== Command: g++ -fpermissive ./sqlite3.cpp -fsyntax-only -I.
==21623==
==21624== Memcheck, a memory error detector
==21624== Copyright (C) 2002-2022, and GNU GPL'd, by Julian Seward et al.
==21624== Using Valgrind-3.21.0 and LibVEX; rerun with -h for copyright info
==21624== Command: /usr/lib/gcc/x86_64-linux-gnu/9/cc1plus -quiet -I . -imultiarch x86_64-linux-gnu -D_GNU_SOURCE ./sqlite3.cpp -quiet -dumpbase sqlite3.cpp -mtune=generic -march=x86-64 -auxbase sqlite3 -fpermissive -fsyntax-only -o /dev/null -fasynchronous-unwind-tables -fstack-protector-strong -Wformat -Wformat-security
==21624==
./sqlite3.cpp: In function ‘void* sqlite3MemMalloc(int)’:
./sqlite3.cpp:26707:44: warning: invalid conversion from ‘void*’ to ‘sqlite3_int64*’ {aka ‘long long int*’} [-fpermissive]
26707 | #define SQLITE_MALLOC(x)             malloc(x)
      |                                      ~~~~~~^~~
      |                                            |
      |                                            void*
./sqlite3.cpp:26773:7: note: in expansion of macro ‘SQLITE_MALLOC’
26773 |   p = SQLITE_MALLOC( nByte+8 );
      |       ^~~~~~~~~~~~~
./sqlite3.cpp: In function ‘void* sqlite3MemRealloc(void*, int)’:
./sqlite3.cpp:26709:45: warning: invalid conversion from ‘void*’ to ‘sqlite3_int64*’ {aka ‘long long int*’} [-fpermissive]
26709 | #define SQLITE_REALLOC(x,y)          realloc((x),(y))
      |                                      ~~~~~~~^~~~~~~~~
      |                                             |
      |                                             void*
./sqlite3.cpp:26846:7: note: in expansion of macro ‘SQLITE_REALLOC’
26846 |   p = SQLITE_REALLOC(p, nByte+8 );
      |       ^~~~~~~~~~~~~~
./sqlite3.cpp: In function ‘sqlite3_mutex* pthreadMutexAlloc(int)’:
./sqlite3.cpp:29487:28: warning: invalid conversion from ‘void*’ to ‘sqlite3_mutex*’ [-fpermissive]
29487 |       p = sqlite3MallocZero( sizeof(*p) );
      |           ~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~
      |                            |
      |                            void*
./sqlite3.cpp:29508:28: warning: invalid conversion from ‘void*’ to ‘sqlite3_mutex*’ [-fpermissive]
29508 |       p = sqlite3MallocZero( sizeof(*p) );
      |           ~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~
      |                            |
      |                            void*
./sqlite3.cpp: In function ‘char* sqlite3DbStrDup(sqlite3*, const char*)’:
./sqlite3.cpp:30997:28: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
30997 |   zNew = sqlite3DbMallocRaw(db, n);
      |          ~~~~~~~~~~~~~~~~~~^~~~~~~
      |                            |
      |                            void*
./sqlite3.cpp: In function ‘char* sqlite3DbStrNDup(sqlite3*, const char*, u64)’:
./sqlite3.cpp:31008:12: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
31008 |   zNew = z ? sqlite3DbMallocRawNN(db, n+1) : 0;
      |          ~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      |            |
      |            void*
./sqlite3.cpp: In function ‘char* printfTempBuf(sqlite3_str*, sqlite3_int64)’:
./sqlite3.cpp:31280:25: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
31280 |   z = sqlite3DbMallocRaw(pAccum->db, n);
      |       ~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~
      |                         |
      |                         void*
./sqlite3.cpp: In function ‘void sqlite3_str_vappendf(sqlite3_str*, const char*, __va_list_tag*)’:
./sqlite3.cpp:31639:34: warning: invalid conversion from ‘const char*’ to ‘char*’ [-fpermissive]
31639 |             bufpt = flag_zeropad ? "null" : "NaN";
      |                     ~~~~~~~~~~~~~^~~~~~~~~~~~~~~~
      |                                  |
      |                                  const char*
./sqlite3.cpp:31861:19: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
31861 |           bufpt = "";
      |                   ^~
./sqlite3.cpp:31919:52: warning: invalid conversion from ‘const char*’ to ‘char*’ [-fpermissive]
31919 |         if( isnull ) escarg = (xtype==etSQLESCAPE2 ? "NULL" : "(NULL)");
      |                               ~~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~
      |                                                    |
      |                                                    const char*
./sqlite3.cpp: In function ‘int sqlite3StrAccumEnlarge(StrAccum*, i64)’:
./sqlite3.cpp:32105:30: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
32105 |       zNew = sqlite3DbRealloc(p->db, zOld, p->nAlloc);
      |              ~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~
      |                              |
      |                              void*
./sqlite3.cpp:32107:28: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
32107 |       zNew = sqlite3Realloc(zOld, p->nAlloc);
      |              ~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~
      |                            |
      |                            void*
./sqlite3.cpp: In function ‘char* strAccumFinishRealloc(StrAccum*)’:
./sqlite3.cpp:32186:29: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
32186 |   zText = sqlite3DbMallocRaw(p->db, p->nChar+1 );
      |           ~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~
      |                             |
      |                             void*
./sqlite3.cpp: In function ‘sqlite3_str* sqlite3_str_new(sqlite3*)’:
./sqlite3.cpp:32301:36: warning: invalid conversion from ‘void*’ to ‘sqlite3_str*’ [-fpermissive]
32301 |   sqlite3_str *p = sqlite3_malloc64(sizeof(*p));
      |                    ~~~~~~~~~~~~~~~~^~~~~~~~~~~~
      |                                    |
      |                                    void*
./sqlite3.cpp: In function ‘char* sqlite3RCStrNew(u64)’:
./sqlite3.cpp:32550:30: warning: invalid conversion from ‘void*’ to ‘RCStr*’ [-fpermissive]
32550 |   RCStr *p = sqlite3_malloc64( N + sizeof(*p) + 1 );
      |              ~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~
      |                              |
      |                              void*
./sqlite3.cpp: In function ‘char* sqlite3RCStrResize(char*, u64)’:
./sqlite3.cpp:32566:27: warning: invalid conversion from ‘void*’ to ‘RCStr*’ [-fpermissive]
32566 |   pNew = sqlite3_realloc64(p, N+sizeof(RCStr)+1);
      |          ~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~
      |                           |
      |                           void*
./sqlite3.cpp: In function ‘void sqlite3_randomness(int, void*)’:
./sqlite3.cpp:33953:25: warning: invalid conversion from ‘void*’ to ‘unsigned char*’ [-fpermissive]
33953 |   unsigned char *zBuf = pBuf;
      |                         ^~~~
      |                         |
      |                         void*
./sqlite3.cpp: In function ‘int sqlite3ThreadCreate(SQLiteThread**, void* (*)(void*), void*)’:
./sqlite3.cpp:34118:20: warning: invalid conversion from ‘void*’ to ‘SQLiteThread*’ [-fpermissive]
34118 |   p = sqlite3Malloc(sizeof(*p));
      |       ~~~~~~~~~~~~~^~~~~~~~~~~~
      |                    |
      |                    void*
./sqlite3.cpp: In function ‘int sqlite3VdbeMemTranslate(Mem*, u8)’:
./sqlite3.cpp:34617:28: warning: invalid conversion from ‘void*’ to ‘unsigned char*’ [-fpermissive]
34617 |   zOut = sqlite3DbMallocRaw(pMem->db, len);
      |          ~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~
      |                            |
      |                            void*
./sqlite3.cpp: In function ‘char* sqlite3Utf16to8(sqlite3*, const void*, int, u8)’:
./sqlite3.cpp:34834:28: warning: invalid conversion from ‘const void*’ to ‘const char*’ [-fpermissive]
34834 |   sqlite3VdbeMemSetStr(&m, z, nByte, enc, SQLITE_STATIC);
      |                            ^
      |                            |
      |                            const void*
./sqlite3.cpp:23708:47: note:   initializing argument 2 of ‘int sqlite3VdbeMemSetStr(Mem*, const char*, i64, u8, void (*)(void*))’
23708 | SQLITE_PRIVATE int sqlite3VdbeMemSetStr(Mem*, const char*, i64, u8, void(*)(void*));
      |                                               ^~~~~~~~~~~
./sqlite3.cpp: In function ‘int sqlite3Utf16ByteLen(const void*, int)’:
./sqlite3.cpp:34853:28: warning: invalid conversion from ‘const void*’ to ‘const unsigned char*’ [-fpermissive]
34853 |   unsigned char const *z = zIn;
      |                            ^~~
      |                            |
      |                            const void*
./sqlite3.cpp: In function ‘void sqlite3FpDecode(FpDecode*, double, int, int)’:
./sqlite3.cpp:35943:12: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
35943 |     p->z = "0";
      |            ^~~
./sqlite3.cpp: In function ‘VList* sqlite3VListAdd(sqlite3*, VList*, const char*, int, int)’:
./sqlite3.cpp:36734:35: warning: invalid conversion from ‘void*’ to ‘VList*’ {aka ‘int*’} [-fpermissive]
36734 |     VList *pOut = sqlite3DbRealloc(db, pIn, nAlloc*sizeof(int));
      |                   ~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      |                                   |
      |                                   void*
./sqlite3.cpp: In function ‘int unixLogErrorAtLine(int, const char*, const char*, int)’:
./sqlite3.cpp:39658:10: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
39658 |   zErr = "";
      |          ^~
./sqlite3.cpp: In function ‘int findInodeInfo(unixFile*, unixInodeInfo**)’:
./sqlite3.cpp:39823:30: warning: invalid conversion from ‘void*’ to ‘unixInodeInfo*’ [-fpermissive]
39823 |     pInode = sqlite3_malloc64( sizeof(*pInode) );
      |              ~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~
      |                              |
      |                              void*
./sqlite3.cpp: In function ‘int unixFileControl(sqlite3_file*, int, void*)’:
./sqlite3.cpp:42395:38: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
42395 |       char *zTFile = sqlite3_malloc64( pFile->pVfs->mxPathname );
      |                      ~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~
      |                                      |
      |                                      void*
./sqlite3.cpp: In function ‘int unixOpenSharedMemory(unixFile*)’:
./sqlite3.cpp:43034:23: warning: invalid conversion from ‘void*’ to ‘unixShm*’ [-fpermissive]
43034 |   p = sqlite3_malloc64( sizeof(*p) );
      |       ~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~
      |                       |
      |                       void*
./sqlite3.cpp:43066:32: warning: invalid conversion from ‘void*’ to ‘unixShmNode*’ [-fpermissive]
43066 |     pShmNode = sqlite3_malloc64( sizeof(*pShmNode) + nShmFilename );
      |                ~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      |                                |
      |                                void*
./sqlite3.cpp: In function ‘void unixRemapfile(unixFile*, i64)’:
./sqlite3.cpp:43696:20: warning: invalid conversion from ‘void*’ to ‘u8*’ {aka ‘unsigned char*’} [-fpermissive]
43696 |     pNew = osMremap(pOrig, nReuse, nNew, MREMAP_MAYMOVE);
      |                    ^
      |                    |
      |                    void*
./sqlite3.cpp:43718:18: warning: invalid conversion from ‘void*’ to ‘u8*’ {aka ‘unsigned char*’} [-fpermissive]
43718 |     pNew = osMmap(0, nNew, flags, MAP_SHARED, h, 0);
      |                  ^
      |                  |
      |                  void*
./sqlite3.cpp: In function ‘int unixOpen(sqlite3_vfs*, const char*, sqlite3_file*, int, int*)’:
./sqlite3.cpp:44693:33: warning: invalid conversion from ‘void*’ to ‘UnixUnusedFd*’ [-fpermissive]
44693 |       pUnused = sqlite3_malloc64(sizeof(*pUnused));
      |                 ~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~
      |                                 |
      |                                 void*
./sqlite3.cpp: In function ‘int memdbEnlarge(MemStore*, sqlite3_int64)’:
./sqlite3.cpp:53139:24: warning: invalid conversion from ‘void*’ to ‘unsigned char*’ [-fpermissive]
53139 |   pNew = sqlite3Realloc(p->aData, newSz);
      |          ~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~
      |                        |
      |                        void*
./sqlite3.cpp: In function ‘int memdbOpen(sqlite3_vfs*, const char*, sqlite3_file*, int, int*)’:
./sqlite3.cpp:53425:24: warning: invalid conversion from ‘void*’ to ‘MemStore*’ [-fpermissive]
53425 |       p = sqlite3Malloc( sizeof(*p) + szName + 3 );
      |           ~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~
      |                        |
      |                        void*
./sqlite3.cpp:53430:29: warning: invalid conversion from ‘void*’ to ‘MemStore**’ [-fpermissive]
53430 |       apNew = sqlite3Realloc(memdb_g.apMemStore,
      |               ~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~
      |                             |
      |                             void*
53431 |                              sizeof(apNew[0])*(memdb_g.nMemStore+1) );
      |                              ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
./sqlite3.cpp:53459:22: warning: invalid conversion from ‘void*’ to ‘MemStore*’ [-fpermissive]
53459 |     p = sqlite3Malloc( sizeof(*p) );
      |         ~~~~~~~~~~~~~^~~~~~~~~~~~~~
      |                      |
      |                      void*
./sqlite3.cpp: In function ‘unsigned char* sqlite3_serialize(sqlite3*, const char*, sqlite3_int64*, unsigned int)’:
./sqlite3.cpp:53640:30: warning: invalid conversion from ‘void*’ to ‘unsigned char*’ [-fpermissive]
53640 |       pOut = sqlite3_malloc64( pStore->sz );
      |              ~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~
      |                              |
      |                              void*
./sqlite3.cpp:53669:30: warning: invalid conversion from ‘void*’ to ‘unsigned char*’ [-fpermissive]
53669 |       pOut = sqlite3_malloc64( sz );
      |              ~~~~~~~~~~~~~~~~^~~~~~
      |                              |
      |                              void*
./sqlite3.cpp: In function ‘Bitvec* sqlite3BitvecCreate(u32)’:
./sqlite3.cpp:53912:24: warning: invalid conversion from ‘void*’ to ‘Bitvec*’ [-fpermissive]
53912 |   p = sqlite3MallocZero( sizeof(*p) );
      |       ~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~
      |                        |
      |                        void*
./sqlite3.cpp: In function ‘int sqlite3BitvecSet(Bitvec*, u32)’:
./sqlite3.cpp:20643:56: warning: invalid conversion from ‘void*’ to ‘u32*’ {aka ‘unsigned int*’} [-fpermissive]
20643 | # define sqlite3StackAllocRaw(D,N)   sqlite3DbMallocRaw(D,N)
      |                                      ~~~~~~~~~~~~~~~~~~^~~~~
      |                                                        |
      |                                                        void*
./sqlite3.cpp:54007:21: note: in expansion of macro ‘sqlite3StackAllocRaw’
54007 |     u32 *aiValues = sqlite3StackAllocRaw(0, sizeof(p->u.aHash));
      |                     ^~~~~~~~~~~~~~~~~~~~
./sqlite3.cpp: In function ‘void sqlite3BitvecClear(Bitvec*, u32, void*)’:
./sqlite3.cpp:54050:21: warning: invalid conversion from ‘void*’ to ‘u32*’ {aka ‘unsigned int*’} [-fpermissive]
54050 |     u32 *aiValues = pBuf;
      |                     ^~~~
      |                     |
      |                     void*
./sqlite3.cpp: In function ‘int sqlite3BitvecBuiltinTest(int, int*)’:
./sqlite3.cpp:54141:25: warning: invalid conversion from ‘void*’ to ‘unsigned char*’ [-fpermissive]
54141 |   pV = sqlite3MallocZero( (sz+7)/8 + 1 );
      |        ~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~
      |                         |
      |                         void*
./sqlite3.cpp: In function ‘int pcache1InitBulk(PCache1*)’:
./sqlite3.cpp:55462:25: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
55462 |   zBulk = pCache->pBulk = sqlite3Malloc( szBulk );
      |           ~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~
      |                         |
      |                         void*
./sqlite3.cpp: In function ‘RowSet* sqlite3RowSetInit(sqlite3*)’:
./sqlite3.cpp:56560:35: warning: invalid conversion from ‘void*’ to ‘RowSet*’ [-fpermissive]
56560 |   RowSet *p = sqlite3DbMallocRawNN(db, sizeof(*p));
      |               ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~
      |                                   |
      |                                   void*
./sqlite3.cpp: In function ‘RowSetEntry* rowSetEntryAlloc(RowSet*)’:
./sqlite3.cpp:56620:32: warning: invalid conversion from ‘void*’ to ‘RowSetChunk*’ [-fpermissive]
56620 |     pNew = sqlite3DbMallocRawNN(p->db, sizeof(*pNew));
      |            ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~
      |                                |
      |                                void*
./sqlite3.cpp: In function ‘int pager_delsuper(Pager*, const char*)’:
./sqlite3.cpp:59658:24: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
59658 |   zFree = sqlite3Malloc(4 + nSuperJournal + nSuperPtr + 2);
      |           ~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      |                        |
      |                        void*
./sqlite3.cpp: In function ‘int readDbPage(PgHdr*)’:
./sqlite3.cpp:60123:73: warning: invalid conversion from ‘void*’ to ‘u8*’ {aka ‘unsigned char*’} [-fpermissive]
60123 |     rc = sqlite3WalReadFrame(pPager->pWal, iFrame,pPager->pageSize,pPg->pData);
      |                                                                    ~~~~~^~~~~
      |                                                                         |
      |                                                                         void*
./sqlite3.cpp:57035:57: note:   initializing argument 4 of ‘int sqlite3WalReadFrame(Wal*, u32, int, u8*)’
57035 | SQLITE_PRIVATE int sqlite3WalReadFrame(Wal *, u32, int, u8 *);
      |                                                         ^~~~
./sqlite3.cpp: In function ‘int pager_write_pagelist(Pager*, PgHdr*)’:
./sqlite3.cpp:61549:22: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
61549 |       pData = pList->pData;
      |               ~~~~~~~^~~~~
      |                      |
      |                      void*
./sqlite3.cpp: In function ‘int subjournalPage(PgHdr*)’:
./sqlite3.cpp:61638:16: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
61638 |       pData2 = pData;
      |                ^~~~~
      |                |
      |                void*
./sqlite3.cpp: In function ‘int sqlite3PagerOpen(sqlite3_vfs*, Pager**, const char*, int, int, int, void (*)(DbPage*))’:
./sqlite3.cpp:61857:35: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
61857 |     zPathname = sqlite3DbMallocRaw(0, nPathname*2);
      |                 ~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~
      |                                   |
      |                                   void*
./sqlite3.cpp: In function ‘int pagerAddPageToRollbackJournal(PgHdr*)’:
./sqlite3.cpp:63074:17: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
63074 |   pData2 = pPg->pData;
      |            ~~~~~^~~~~
      |                 |
      |                 void*
./sqlite3.cpp: In function ‘int walWriteOneFrame(WalWriter*, PgHdr*, int, sqlite3_int64)’:
./sqlite3.cpp:68828:51: warning: invalid conversion from ‘void*’ to ‘u8*’ {aka ‘unsigned char*’} [-fpermissive]
68828 |   walEncodeFrame(p->pWal, pPage->pgno, nTruncate, pData, aFrame);
      |                                                   ^~~~~
      |                                                   |
      |                                                   void*
./sqlite3.cpp:65867:7: note:   initializing argument 4 of ‘void walEncodeFrame(Wal*, u32, u32, u8*, u8*)’
65867 |   u8 *aData,                      /* Pointer to page data */
      |   ~~~~^~~~~
./sqlite3.cpp: In function ‘int walRewriteChecksums(Wal*, u32)’:
./sqlite3.cpp:68852:24: warning: invalid conversion from ‘void*’ to ‘u8*’ {aka ‘unsigned char*’} [-fpermissive]
68852 |   aBuf = sqlite3_malloc(szPage + WAL_FRAME_HDRSIZE);
      |          ~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~
      |                        |
      |                        void*
./sqlite3.cpp: In function ‘int defragmentPage(MemPage*, int)’:
./sqlite3.cpp:72218:33: warning: invalid conversion from ‘void*’ to ‘unsigned char*’ [-fpermissive]
72218 |     temp = sqlite3PagerTempSpace(pPage->pBt->pPager);
      |            ~~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~
      |                                 |
      |                                 void*
./sqlite3.cpp: In function ‘MemPage* btreePageFromDbPage(DbPage*, Pgno, BtShared*)’:
./sqlite3.cpp:72835:39: warning: invalid conversion from ‘void*’ to ‘u8*’ {aka ‘unsigned char*’} [-fpermissive]
72835 |     pPage->aData = sqlite3PagerGetData(pDbPage);
      |                    ~~~~~~~~~~~~~~~~~~~^~~~~~~~~
      |                                       |
      |                                       void*
./sqlite3.cpp: In function ‘int sqlite3BtreeOpen(sqlite3_vfs*, const char*, sqlite3*, Btree**, int, int)’:
./sqlite3.cpp:73102:24: warning: invalid conversion from ‘void*’ to ‘Btree*’ [-fpermissive]
73102 |   p = sqlite3MallocZero(sizeof(Btree));
      |       ~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~
      |                        |
      |                        void*
./sqlite3.cpp:73122:42: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
73122 |       char *zFullPathname = sqlite3Malloc(MAX(nFullPathname,nFilename));
      |                             ~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      |                                          |
      |                                          void*
./sqlite3.cpp:73201:28: warning: invalid conversion from ‘void*’ to ‘BtShared*’ [-fpermissive]
73201 |     pBt = sqlite3MallocZero( sizeof(*pBt) );
      |           ~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~
      |                            |
      |                            void*
./sqlite3.cpp: In function ‘int allocateTempSpace(BtShared*)’:
./sqlite3.cpp:73402:37: warning: invalid conversion from ‘void*’ to ‘u8*’ {aka ‘unsigned char*’} [-fpermissive]
73402 |   pBt->pTmpSpace = sqlite3PageMalloc( pBt->pageSize );
      |                    ~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~
      |                                     |
      |                                     void*
./sqlite3.cpp: In function ‘int accessPayload(BtCursor*, u32, u32, unsigned char*, int)’:
./sqlite3.cpp:75766:43: warning: invalid conversion from ‘void*’ to ‘unsigned char*’ [-fpermissive]
75766 |             aPayload = sqlite3PagerGetData(pDbPage);
      |                        ~~~~~~~~~~~~~~~~~~~^~~~~~~~~
      |                                           |
      |                                           void*
./sqlite3.cpp: In function ‘int accessPayloadChecked(BtCursor*, u32, u32, void*)’:
./sqlite3.cpp:75831:53: warning: invalid conversion from ‘void*’ to ‘unsigned char*’ [-fpermissive]
75831 |   return rc ? rc : accessPayload(pCur, offset, amt, pBuf, 0);
      |                                                     ^~~~
      |                                                     |
      |                                                     void*
./sqlite3.cpp:75598:18: note:   initializing argument 4 of ‘int accessPayload(BtCursor*, u32, u32, unsigned char*, int)’
75598 |   unsigned char *pBuf, /* Write the bytes into this buffer */
      |   ~~~~~~~~~~~~~~~^~~~
./sqlite3.cpp: In function ‘int sqlite3BtreePayloadChecked(BtCursor*, u32, u32, void*)’:
./sqlite3.cpp:75836:45: warning: invalid conversion from ‘void*’ to ‘unsigned char*’ [-fpermissive]
75836 |     return accessPayload(pCur, offset, amt, pBuf, 0);
      |                                             ^~~~
      |                                             |
      |                                             void*
./sqlite3.cpp:75598:18: note:   initializing argument 4 of ‘int accessPayload(BtCursor*, u32, u32, unsigned char*, int)’
75598 |   unsigned char *pBuf, /* Write the bytes into this buffer */
      |   ~~~~~~~~~~~~~~~^~~~
./sqlite3.cpp: In function ‘int fillInCell(MemPage*, unsigned char*, const BtreePayload*, int*)’:
./sqlite3.cpp:77537:16: warning: invalid conversion from ‘const void*’ to ‘const u8*’ {aka ‘const unsigned char*’} [-fpermissive]
77537 |     pSrc = pX->pData;
      |            ~~~~^~~~~
      |                |
      |                const void*
./sqlite3.cpp:77545:16: warning: invalid conversion from ‘const void*’ to ‘const u8*’ {aka ‘const unsigned char*’} [-fpermissive]
77545 |     pSrc = pX->pKey;
      |            ~~~~^~~~
      |                |
      |                const void*
./sqlite3.cpp: In function ‘int rebuildPage(CellArray*, int, int, MemPage*)’:
./sqlite3.cpp:78093:35: warning: invalid conversion from ‘void*’ to ‘u8*’ {aka ‘unsigned char*’} [-fpermissive]
78093 |   u8 *pTmp = sqlite3PagerTempSpace(pPg->pBt->pPager);
      |              ~~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~
      |                                   |
      |                                   void*
./sqlite3.cpp: In function ‘int balance_nonroot(MemPage*, int, u8*, int, int)’:
./sqlite3.cpp:20643:56: warning: invalid conversion from ‘void*’ to ‘u8**’ {aka ‘unsigned char**’} [-fpermissive]
20643 | # define sqlite3StackAllocRaw(D,N)   sqlite3DbMallocRaw(D,N)
      |                                      ~~~~~~~~~~~~~~~~~~^~~~~
      |                                                        |
      |                                                        void*
./sqlite3.cpp:78825:14: note: in expansion of macro ‘sqlite3StackAllocRaw’
78825 |   b.apCell = sqlite3StackAllocRaw(0, szScratch );
      |              ^~~~~~~~~~~~~~~~~~~~
./sqlite3.cpp: In function ‘int balance(BtCursor*)’:
./sqlite3.cpp:79646:41: warning: invalid conversion from ‘void*’ to ‘u8*’ {aka ‘unsigned char*’} [-fpermissive]
79646 |           u8 *pSpace = sqlite3PageMalloc(pCur->pBt->pageSize);
      |                        ~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~
      |                                         |
      |                                         void*
./sqlite3.cpp: In function ‘int sqlite3BtreeIntegrityCheck(sqlite3*, Btree*, Pgno*, Mem*, int, int, int*, char**)’:
./sqlite3.cpp:81605:36: warning: invalid conversion from ‘void*’ to ‘u8*’ {aka ‘unsigned char*’} [-fpermissive]
81605 |   sCheck.aPgRef = sqlite3MallocZero((sCheck.nCkPage / 8)+ 1);
      |                   ~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~
      |                                    |
      |                                    void*
./sqlite3.cpp: In function ‘int backupOnePage(sqlite3_backup*, Pgno, const u8*, int)’:
./sqlite3.cpp:82262:42: warning: invalid conversion from ‘void*’ to ‘u8*’ {aka ‘unsigned char*’} [-fpermissive]
82262 |       u8 *zDestData = sqlite3PagerGetData(pDestPg);
      |                       ~~~~~~~~~~~~~~~~~~~^~~~~~~~~
      |                                          |
      |                                          void*
./sqlite3.cpp: In function ‘int sqlite3_backup_step(sqlite3_backup*, int)’:
./sqlite3.cpp:82399:60: warning: invalid conversion from ‘void*’ to ‘const u8*’ {aka ‘const unsigned char*’} [-fpermissive]
82399 |           rc = backupOnePage(p, iSrcPg, sqlite3PagerGetData(pSrcPg), 0);
      |                                         ~~~~~~~~~~~~~~~~~~~^~~~~~~~
      |                                                            |
      |                                                            void*
./sqlite3.cpp:82232:13: note:   initializing argument 3 of ‘int backupOnePage(sqlite3_backup*, Pgno, const u8*, int)’
82232 |   const u8 *zSrcData,             /* Source database page data */
      |   ~~~~~~~~~~^~~~~~~~
./sqlite3.cpp:82519:46: warning: invalid conversion from ‘void*’ to ‘u8*’ {aka ‘unsigned char*’} [-fpermissive]
82519 |               u8 *zData = sqlite3PagerGetData(pSrcPg);
      |                           ~~~~~~~~~~~~~~~~~~~^~~~~~~~
      |                                              |
      |                                              void*
./sqlite3.cpp: In function ‘int sqlite3VdbeMemGrow(Mem*, int, int)’:
./sqlite3.cpp:83031:55: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
83031 |       pMem->z = pMem->zMalloc = sqlite3DbReallocOrFree(pMem->db, pMem->z, n);
      |                                 ~~~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~
      |                                                       |
      |                                                       void*
./sqlite3.cpp:83033:37: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
83033 |       pMem->zMalloc = sqlite3Realloc(pMem->z, n);
      |                       ~~~~~~~~~~~~~~^~~~~~~~~~~~
      |                                     |
      |                                     void*
./sqlite3.cpp:83040:39: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
83040 |     pMem->zMalloc = sqlite3DbMallocRaw(pMem->db, n);
      |                     ~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~
      |                                       |
      |                                       void*
./sqlite3.cpp: In function ‘void sqlite3VdbeMemSetPointer(Mem*, void*, const char*, void (*)(void*))’:
./sqlite3.cpp:83742:13: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
83742 |   pMem->z = pPtr;
      |             ^~~~
      |             |
      |             void*
./sqlite3.cpp: In function ‘sqlite3_value* sqlite3ValueNew(sqlite3*)’:
./sqlite3.cpp:84176:31: warning: invalid conversion from ‘void*’ to ‘Mem*’ {aka ‘sqlite3_value*’} [-fpermissive]
84176 |   Mem *p = sqlite3DbMallocZero(db, sizeof(*p));
      |            ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~
      |                               |
      |                               void*
./sqlite3.cpp: In function ‘int valueFromExpr(sqlite3*, const Expr*, u8, u8, sqlite3_value**, ValueNewStat4Ctx*)’:
./sqlite3.cpp:84504:48: warning: invalid conversion from ‘void*’ to ‘const char*’ [-fpermissive]
84504 |     sqlite3VdbeMemSetStr(pVal, sqlite3HexToBlob(db, zVal, nVal), nVal/2,
      |                                ~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~
      |                                                |
      |                                                void*
./sqlite3.cpp:83933:15: note:   initializing argument 2 of ‘int sqlite3VdbeMemSetStr(Mem*, const char*, i64, u8, void (*)(void*))’
83933 |   const char *z,      /* String pointer */
      |   ~~~~~~~~~~~~^
./sqlite3.cpp: In function ‘void sqlite3ValueSetStr(sqlite3_value*, int, const void*, u8, void (*)(void*))’:
./sqlite3.cpp:84787:42: warning: invalid conversion from ‘const void*’ to ‘const char*’ [-fpermissive]
84787 |   if( v ) sqlite3VdbeMemSetStr((Mem *)v, z, n, enc, xDel);
      |                                          ^
      |                                          |
      |                                          const void*
./sqlite3.cpp:83933:15: note:   initializing argument 2 of ‘int sqlite3VdbeMemSetStr(Mem*, const char*, i64, u8, void (*)(void*))’
83933 |   const char *z,      /* String pointer */
      |   ~~~~~~~~~~~~^
./sqlite3.cpp: In function ‘Vdbe* sqlite3VdbeCreate(Parse*)’:
./sqlite3.cpp:84856:27: warning: invalid conversion from ‘void*’ to ‘Vdbe*’ [-fpermissive]
84856 |   p = sqlite3DbMallocRawNN(db, sizeof(Vdbe) );
      |       ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~
      |                           |
      |                           void*
./sqlite3.cpp: In function ‘int growOpArray(Vdbe*, int)’:
./sqlite3.cpp:85020:26: warning: invalid conversion from ‘void*’ to ‘VdbeOp*’ [-fpermissive]
85020 |   pNew = sqlite3DbRealloc(p->db, v->aOp, nNew*sizeof(Op));
      |          ~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      |                          |
      |                          void*
./sqlite3.cpp: In function ‘int sqlite3VdbeAddFunctionCall(Parse*, int, int, int, int, const FuncDef*, int)’:
./sqlite3.cpp:85281:30: warning: invalid conversion from ‘void*’ to ‘sqlite3_context*’ [-fpermissive]
85281 |   pCtx = sqlite3DbMallocRawNN(pParse->db, nByte);
      |          ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~
      |                              |
      |                              void*
./sqlite3.cpp: In function ‘int sqlite3VdbeAddOp4Dup8(Vdbe*, int, int, int, int, const u8*, int)’:
./sqlite3.cpp:85313:38: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
85313 |   char *p4copy = sqlite3DbMallocRawNN(sqlite3VdbeDb(p), 8);
      |                  ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~
      |                                      |
      |                                      void*
./sqlite3.cpp: In function ‘void resizeResolveLabel(Parse*, Vdbe*, int)’:
./sqlite3.cpp:85451:37: warning: invalid conversion from ‘void*’ to ‘int*’ [-fpermissive]
85451 |   p->aLabel = sqlite3DbReallocOrFree(p->db, p->aLabel,
      |               ~~~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~
      |                                     |
      |                                     void*
85452 |                      nNewSize*sizeof(p->aLabel[0]));
      |                      ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
./sqlite3.cpp: In function ‘char* sqlite3VdbeDisplayP4(sqlite3*, Op*)’:
./sqlite3.cpp:86790:15: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
86790 |         zP4 = "NULL";
      |               ^~~~~~
./sqlite3.cpp:86793:15: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
86793 |         zP4 = "(blob)";
      |               ^~~~~~~~
./sqlite3.cpp:86816:13: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
86816 |       zP4 = "program";
      |             ^~~~~~~~~
./sqlite3.cpp: In function ‘void sqlite3VdbeMakeReady(Vdbe*, Parse*)’:
./sqlite3.cpp:87517:23: warning: invalid conversion from ‘void*’ to ‘Mem*’ {aka ‘sqlite3_value*’} [-fpermissive]
87517 |   p->aMem = allocSpace(&x, 0, nMem*sizeof(Mem));
      |             ~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~
      |                       |
      |                       void*
./sqlite3.cpp:87518:23: warning: invalid conversion from ‘void*’ to ‘Mem*’ {aka ‘sqlite3_value*’} [-fpermissive]
87518 |   p->aVar = allocSpace(&x, 0, nVar*sizeof(Mem));
      |             ~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~
      |                       |
      |                       void*
./sqlite3.cpp:87519:24: warning: invalid conversion from ‘void*’ to ‘Mem**’ {aka ‘sqlite3_value**’} [-fpermissive]
87519 |   p->apArg = allocSpace(&x, 0, nArg*sizeof(Mem*));
      |              ~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~
      |                        |
      |                        void*
./sqlite3.cpp:87520:24: warning: invalid conversion from ‘void*’ to ‘VdbeCursor**’ [-fpermissive]
87520 |   p->apCsr = allocSpace(&x, 0, nCursor*sizeof(VdbeCursor*));
      |              ~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      |                        |
      |                        void*
./sqlite3.cpp:87522:25: warning: invalid conversion from ‘void*’ to ‘u8*’ {aka ‘unsigned char*’} [-fpermissive]
87522 |     x.pSpace = p->pFree = sqlite3DbMallocRawNN(db, x.nNeeded);
      |                ~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      |                         |
      |                         void*
./sqlite3.cpp:87525:27: warning: invalid conversion from ‘void*’ to ‘Mem*’ {aka ‘sqlite3_value*’} [-fpermissive]
87525 |       p->aMem = allocSpace(&x, p->aMem, nMem*sizeof(Mem));
      |                 ~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      |                           |
      |                           void*
./sqlite3.cpp:87526:27: warning: invalid conversion from ‘void*’ to ‘Mem*’ {aka ‘sqlite3_value*’} [-fpermissive]
87526 |       p->aVar = allocSpace(&x, p->aVar, nVar*sizeof(Mem));
      |                 ~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      |                           |
      |                           void*
./sqlite3.cpp:87527:28: warning: invalid conversion from ‘void*’ to ‘Mem**’ {aka ‘sqlite3_value**’} [-fpermissive]
87527 |       p->apArg = allocSpace(&x, p->apArg, nArg*sizeof(Mem*));
      |                  ~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      |                            |
      |                            void*
./sqlite3.cpp:87528:28: warning: invalid conversion from ‘void*’ to ‘VdbeCursor**’ [-fpermissive]
87528 |       p->apCsr = allocSpace(&x, p->apCsr, nCursor*sizeof(VdbeCursor*));
      |                  ~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      |                            |
      |                            void*
./sqlite3.cpp: In function ‘sqlite3_value* sqlite3_value_dup(const sqlite3_value*)’:
./sqlite3.cpp:90714:24: warning: invalid conversion from ‘void*’ to ‘sqlite3_value*’ [-fpermissive]
90714 |   pNew = sqlite3_malloc( sizeof(*pNew) );
      |          ~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~
      |                        |
      |                        void*
./sqlite3.cpp: In function ‘void sqlite3_result_blob(sqlite3_context*, const void*, int, void (*)(void*))’:
./sqlite3.cpp:90815:29: warning: invalid conversion from ‘const void*’ to ‘const char*’ [-fpermissive]
90815 |   setResultStrOrError(pCtx, z, n, 0, xDel);
      |                             ^
      |                             |
      |                             const void*
./sqlite3.cpp:90755:15: note:   initializing argument 2 of ‘void setResultStrOrError(sqlite3_context*, const char*, int, u8, void (*)(void*))’
90755 |   const char *z,          /* String pointer */
      |   ~~~~~~~~~~~~^
./sqlite3.cpp: In function ‘void sqlite3_result_blob64(sqlite3_context*, const void*, sqlite3_uint64, void (*)(void*))’:
./sqlite3.cpp:90834:31: warning: invalid conversion from ‘const void*’ to ‘const char*’ [-fpermissive]
90834 |     setResultStrOrError(pCtx, z, (int)n, 0, xDel);
      |                               ^
      |                               |
      |                               const void*
./sqlite3.cpp:90755:15: note:   initializing argument 2 of ‘void setResultStrOrError(sqlite3_context*, const char*, int, u8, void (*)(void*))’
90755 |   const char *z,          /* String pointer */
      |   ~~~~~~~~~~~~^
./sqlite3.cpp: In function ‘void sqlite3_result_error16(sqlite3_context*, const void*, int)’:
./sqlite3.cpp:90859:36: warning: invalid conversion from ‘const void*’ to ‘const char*’ [-fpermissive]
90859 |   sqlite3VdbeMemSetStr(pCtx->pOut, z, n, SQLITE_UTF16NATIVE, SQLITE_TRANSIENT);
      |                                    ^
      |                                    |
      |                                    const void*
./sqlite3.cpp:83933:15: note:   initializing argument 2 of ‘int sqlite3VdbeMemSetStr(Mem*, const char*, i64, u8, void (*)(void*))’
83933 |   const char *z,      /* String pointer */
      |   ~~~~~~~~~~~~^
./sqlite3.cpp: In function ‘void sqlite3_result_text16(sqlite3_context*, const void*, int, void (*)(void*))’:
./sqlite3.cpp:90973:29: warning: invalid conversion from ‘const void*’ to ‘const char*’ [-fpermissive]
90973 |   setResultStrOrError(pCtx, z, n & ~(u64)1, SQLITE_UTF16NATIVE, xDel);
      |                             ^
      |                             |
      |                             const void*
./sqlite3.cpp:90755:15: note:   initializing argument 2 of ‘void setResultStrOrError(sqlite3_context*, const char*, int, u8, void (*)(void*))’
90755 |   const char *z,          /* String pointer */
      |   ~~~~~~~~~~~~^
./sqlite3.cpp: In function ‘void sqlite3_result_text16be(sqlite3_context*, const void*, int, void (*)(void*))’:
./sqlite3.cpp:90982:29: warning: invalid conversion from ‘const void*’ to ‘const char*’ [-fpermissive]
90982 |   setResultStrOrError(pCtx, z, n & ~(u64)1, SQLITE_UTF16BE, xDel);
      |                             ^
      |                             |
      |                             const void*
./sqlite3.cpp:90755:15: note:   initializing argument 2 of ‘void setResultStrOrError(sqlite3_context*, const char*, int, u8, void (*)(void*))’
90755 |   const char *z,          /* String pointer */
      |   ~~~~~~~~~~~~^
./sqlite3.cpp: In function ‘void sqlite3_result_text16le(sqlite3_context*, const void*, int, void (*)(void*))’:
./sqlite3.cpp:90991:29: warning: invalid conversion from ‘const void*’ to ‘const char*’ [-fpermissive]
90991 |   setResultStrOrError(pCtx, z, n & ~(u64)1, SQLITE_UTF16LE, xDel);
      |                             ^
      |                             |
      |                             const void*
./sqlite3.cpp:90755:15: note:   initializing argument 2 of ‘void setResultStrOrError(sqlite3_context*, const char*, int, u8, void (*)(void*))’
90755 |   const char *z,          /* String pointer */
      |   ~~~~~~~~~~~~^
./sqlite3.cpp: In function ‘void sqlite3_set_auxdata(sqlite3_context*, int, void*, void (*)(void*))’:
./sqlite3.cpp:91574:35: warning: invalid conversion from ‘void*’ to ‘AuxData*’ [-fpermissive]
91574 |     pAuxData = sqlite3DbMallocZero(pVdbe->db, sizeof(AuxData));
      |                ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~
      |                                   |
      |                                   void*
./sqlite3.cpp: In function ‘const char* sqlite3_column_name(sqlite3_stmt*, int)’:
./sqlite3.cpp:91898:20: warning: invalid conversion from ‘const void*’ to ‘const char*’ [-fpermissive]
91898 |   return columnName(pStmt, N, 0, COLNAME_NAME);
      |          ~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~
      |                    |
      |                    const void*
./sqlite3.cpp: In function ‘const char* sqlite3_column_decltype(sqlite3_stmt*, int)’:
./sqlite3.cpp:91921:20: warning: invalid conversion from ‘const void*’ to ‘const char*’ [-fpermissive]
91921 |   return columnName(pStmt, N, 0, COLNAME_DECLTYPE);
      |          ~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      |                    |
      |                    const void*
./sqlite3.cpp: In function ‘int bindText(sqlite3_stmt*, int, const void*, i64, void (*)(void*), u8)’:
./sqlite3.cpp:92048:39: warning: invalid conversion from ‘const void*’ to ‘const char*’ [-fpermissive]
92048 |       rc = sqlite3VdbeMemSetStr(pVar, zData, nData, encoding, xDel);
      |                                       ^~~~~
      |                                       |
      |                                       const void*
./sqlite3.cpp:83933:15: note:   initializing argument 2 of ‘int sqlite3VdbeMemSetStr(Mem*, const char*, i64, u8, void (*)(void*))’
83933 |   const char *z,      /* String pointer */
      |   ~~~~~~~~~~~~^
./sqlite3.cpp: In function ‘VdbeCursor* allocateCursor(Vdbe*, int, int, u8)’:
./sqlite3.cpp:93395:49: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
93395 |     pMem->z = pMem->zMalloc = sqlite3DbMallocRaw(pMem->db, nByte);
      |                               ~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~
      |                                                 |
      |                                                 void*
./sqlite3.cpp: In function ‘int vdbeColumnFromOverflow(VdbeCursor*, int, int, i64, u32, u32, Mem*)’:
./sqlite3.cpp:93840:39: warning: invalid conversion from ‘void*’ to ‘VdbeTxtBlbCache*’ [-fpermissive]
93840 |       pC->pCache = sqlite3DbMallocZero(db, sizeof(VdbeTxtBlbCache) );
      |                    ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      |                                       |
      |                                       void*
./sqlite3.cpp: In function ‘int sqlite3VdbeExec(Vdbe*)’:
./sqlite3.cpp:96089:42: warning: invalid conversion from ‘const void*’ to ‘const u8*’ {aka ‘const unsigned char*’} [-fpermissive]
96089 |       pC->aRow = sqlite3BtreePayloadFetch(pCrsr, &pC->szRow);
      |                  ~~~~~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~
      |                                          |
      |                                          const void*
./sqlite3.cpp:96901:34: warning: invalid conversion from ‘void*’ to ‘Savepoint*’ [-fpermissive]
96901 |       pNew = sqlite3DbMallocRawNN(db, sizeof(Savepoint)+nName+1);
      |              ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      |                                  |
      |                                  void*
./sqlite3.cpp:97596:23: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
97596 |     aMem[pOp->p3].z = "";
      |                       ^~
./sqlite3.cpp:100472:33: warning: invalid conversion from ‘void*’ to ‘VdbeFrame*’ [-fpermissive]
100472 |     pFrame = sqlite3DbMallocZero(db, nByte);
       |              ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~
       |                                 |
       |                                 void*
./sqlite3.cpp:100789:30: warning: invalid conversion from ‘void*’ to ‘sqlite3_context*’ [-fpermissive]
100789 |   pCtx = sqlite3DbMallocRawNN(db, n*sizeof(sqlite3_value*) +
       |          ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                              |
       |                              void*
100790 |                (sizeof(pCtx[0]) + sizeof(Mem) - sizeof(sqlite3_value*)));
       |                ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
./sqlite3.cpp:101384:26: warning: invalid conversion from ‘void*’ to ‘ValueList*’ [-fpermissive]
101384 |   pRhs = sqlite3_malloc64( sizeof(*pRhs) );
       |          ~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~
       |                          |
       |                          void*
./sqlite3.cpp: In function ‘int vdbePmaReadBlob(PmaReader*, int, u8**)’:
./sqlite3.cpp:103352:28: warning: invalid conversion from ‘void*’ to ‘u8*’ {aka ‘unsigned char*’} [-fpermissive]
103352 |       aNew = sqlite3Realloc(p->aAlloc, nNew);
       |              ~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~
       |                            |
       |                            void*
./sqlite3.cpp: In function ‘int vdbeSorterListToPMA(SortSubtask*, SorterList*)’:
./sqlite3.cpp:103266:19: warning: invalid conversion from ‘void*’ to ‘u8*’ {aka ‘unsigned char*’} [-fpermissive]
103266 | #define SRVAL(p) ((void*)((SorterRecord*)(p) + 1))
       |                  ~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                   |
       |                   void*
./sqlite3.cpp:104402:33: note: in expansion of macro ‘SRVAL’
104402 |       vdbePmaWriteBlob(&writer, SRVAL(p), p->nVal);
       |                                 ^~~~~
./sqlite3.cpp:104285:48: note:   initializing argument 2 of ‘void vdbePmaWriteBlob(PmaWriter*, u8*, int)’
104285 | static void vdbePmaWriteBlob(PmaWriter *p, u8 *pData, int nData){
       |                                            ~~~~^~~~~
./sqlite3.cpp: In function ‘int vdbeSorterFlushPMA(VdbeSorter*)’:
./sqlite3.cpp:104562:46: warning: invalid conversion from ‘void*’ to ‘u8*’ {aka ‘unsigned char*’} [-fpermissive]
104562 |         pSorter->list.aMemory = sqlite3Malloc(pSorter->nMemory);
       |                                 ~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~
       |                                              |
       |                                              void*
./sqlite3.cpp: In function ‘int sqlite3VdbeSorterWrite(const VdbeCursor*, Mem*)’:
./sqlite3.cpp:104655:28: warning: invalid conversion from ‘void*’ to ‘u8*’ {aka ‘unsigned char*’} [-fpermissive]
104655 |       aNew = sqlite3Realloc(pSorter->list.aMemory, nNew);
       |              ~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                            |
       |                            void*
./sqlite3.cpp: In function ‘int memjrnlRead(sqlite3_file*, void*, int, sqlite_int64)’:
./sqlite3.cpp:106121:14: warning: invalid conversion from ‘void*’ to ‘u8*’ {aka ‘unsigned char*’} [-fpermissive]
106121 |   u8 *zOut = zBuf;
       |              ^~~~
       |              |
       |              void*
./sqlite3.cpp: In function ‘int memjrnlWrite(sqlite3_file*, const void*, int, sqlite_int64)’:
./sqlite3.cpp:106258:43: warning: invalid conversion from ‘void*’ to ‘FileChunk*’ [-fpermissive]
106258 |           FileChunk *pNew = sqlite3_malloc(fileChunkSize(p->nChunkSize));
       |                             ~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                           |
       |                                           void*
./sqlite3.cpp: In function ‘int lookupName(Parse*, const char*, const char*, const Expr*, NameContext*, Expr*)’:
./sqlite3.cpp:107513:27: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
107513 |         pExpr->u.zToken = "coalesce";
       |                           ^~~~~~~~~~
./sqlite3.cpp: In function ‘int codeCompare(Parse*, Expr*, Expr*, int, int, int, int, int, int)’:
./sqlite3.cpp:109494:28: warning: invalid conversion from ‘void*’ to ‘const char*’ [-fpermissive]
109494 |                            (void*)p4, P4_COLLSEQ);
       |                            ^~~~~~~~~
       |                            |
       |                            void*
./sqlite3.cpp:85248:15: note:   initializing argument 6 of ‘int sqlite3VdbeAddOp4(Vdbe*, int, int, int, int, const char*, int)’
85248 |   const char *zP4,    /* The P4 operand */
      |   ~~~~~~~~~~~~^~~
./sqlite3.cpp: In function ‘Expr* sqlite3ExprAlloc(sqlite3*, int, const Token*, int)’:
./sqlite3.cpp:109958:30: warning: invalid conversion from ‘void*’ to ‘Expr*’ [-fpermissive]
109958 |   pNew = sqlite3DbMallocRawNN(db, sizeof(Expr)+nExtra);
       |          ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~
       |                              |
       |                              void*
./sqlite3.cpp: In function ‘Expr* sqlite3PExpr(Parse*, int, Expr*, Expr*)’:
./sqlite3.cpp:110053:27: warning: invalid conversion from ‘void*’ to ‘Expr*’ [-fpermissive]
110053 |   p = sqlite3DbMallocRawNN(pParse->db, sizeof(Expr));
       |       ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~
       |                           |
       |                           void*
./sqlite3.cpp: In function ‘Expr* exprDup(sqlite3*, const Expr*, int, EdupBuf*)’:
./sqlite3.cpp:110639:43: warning: invalid conversion from ‘void*’ to ‘u8*’ {aka ‘unsigned char*’} [-fpermissive]
110639 |     sEdupBuf.zAlloc = sqlite3DbMallocRawNN(db, nAlloc);
       |                       ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~
       |                                           |
       |                                           void*
./sqlite3.cpp: In function ‘With* sqlite3WithDup(sqlite3*, With*)’:
./sqlite3.cpp:110755:31: warning: invalid conversion from ‘void*’ to ‘With*’ [-fpermissive]
110755 |     pRet = sqlite3DbMallocZero(db, nByte);
       |            ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~
       |                               |
       |                               void*
./sqlite3.cpp: In function ‘ExprList* sqlite3ExprListDup(sqlite3*, const ExprList*, int)’:
./sqlite3.cpp:110836:30: warning: invalid conversion from ‘void*’ to ‘ExprList*’ [-fpermissive]
110836 |   pNew = sqlite3DbMallocRawNN(db, sqlite3DbMallocSize(db, p));
       |          ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                              |
       |                              void*
./sqlite3.cpp: In function ‘SrcList* sqlite3SrcListDup(sqlite3*, const SrcList*, int)’:
./sqlite3.cpp:110886:30: warning: invalid conversion from ‘void*’ to ‘SrcList*’ [-fpermissive]
110886 |   pNew = sqlite3DbMallocRawNN(db, nByte );
       |          ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~
       |                              |
       |                              void*
./sqlite3.cpp: In function ‘IdList* sqlite3IdListDup(sqlite3*, const IdList*)’:
./sqlite3.cpp:110935:30: warning: invalid conversion from ‘void*’ to ‘IdList*’ [-fpermissive]
110935 |   pNew = sqlite3DbMallocRawNN(db, sizeof(*pNew)+(p->nId-1)*sizeof(p->a[0]) );
       |          ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                              |
       |                              void*
./sqlite3.cpp: In function ‘Select* sqlite3SelectDup(sqlite3*, const Select*, int)’:
./sqlite3.cpp:110955:40: warning: invalid conversion from ‘void*’ to ‘Select*’ [-fpermissive]
110955 |     Select *pNew = sqlite3DbMallocRawNN(db, sizeof(*p) );
       |                    ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~
       |                                        |
       |                                        void*
./sqlite3.cpp: In function ‘ExprList* sqlite3ExprListAppendNew(sqlite3*, Expr*)’:
./sqlite3.cpp:111022:31: warning: invalid conversion from ‘void*’ to ‘ExprList*’ [-fpermissive]
111022 |   pList = sqlite3DbMallocRawNN(db, sizeof(ExprList)+sizeof(pList->a[0])*4 );
       |           ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                               |
       |                               void*
./sqlite3.cpp: In function ‘ExprList* sqlite3ExprListAppendGrow(sqlite3*, ExprList*, Expr*)’:
./sqlite3.cpp:111042:26: warning: invalid conversion from ‘void*’ to ‘ExprList*’ [-fpermissive]
111042 |   pNew = sqlite3DbRealloc(db, pList,
       |          ~~~~~~~~~~~~~~~~^~~~~~~~~~~
       |                          |
       |                          void*
111043 |        sizeof(*pList)+(pList->nAlloc-1)*sizeof(pList->a[0]));
       |        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
./sqlite3.cpp: In function ‘char* exprINAffinity(Parse*, const Expr*)’:
./sqlite3.cpp:112357:28: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
112357 |   zRet = sqlite3DbMallocRaw(pParse->db, nVal+1);
       |          ~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~
       |                            |
       |                            void*
./sqlite3.cpp: In function ‘void sqlite3CodeRhsOfIN(Parse*, Expr*, int)’:
./sqlite3.cpp:112603:34: warning: invalid conversion from ‘void*’ to ‘const char*’ [-fpermissive]
112603 |     sqlite3VdbeChangeP4(v, addr, (void *)pKeyInfo, P4_KEYINFO);
       |                                  ^~~~~~~~~~~~~~~~
       |                                  |
       |                                  void*
./sqlite3.cpp:86383:72: note:   initializing argument 3 of ‘void sqlite3VdbeChangeP4(Vdbe*, int, const char*, int)’
86383 | SQLITE_PRIVATE void sqlite3VdbeChangeP4(Vdbe *p, int addr, const char *zP4, int n){
      |                                                            ~~~~~~~~~~~~^~~
./sqlite3.cpp: In function ‘void sqlite3ExprCodeIN(Parse*, Expr*, int, int)’:
./sqlite3.cpp:112921:27: warning: invalid conversion from ‘void*’ to ‘const char*’ [-fpermissive]
112921 |                           (void*)pColl, P4_COLLSEQ);
       |                           ^~~~~~~~~~~~
       |                           |
       |                           void*
./sqlite3.cpp:85248:15: note:   initializing argument 6 of ‘int sqlite3VdbeAddOp4(Vdbe*, int, int, int, int, const char*, int)’
85248 |   const char *zP4,    /* The P4 operand */
      |   ~~~~~~~~~~~~^~~
./sqlite3.cpp:112931:27: warning: invalid conversion from ‘void*’ to ‘const char*’ [-fpermissive]
112931 |                           (void*)pColl, P4_COLLSEQ);
       |                           ^~~~~~~~~~~~
       |                           |
       |                           void*
./sqlite3.cpp:85248:15: note:   initializing argument 6 of ‘int sqlite3VdbeAddOp4(Vdbe*, int, int, int, int, const char*, int)’
85248 |   const char *zP4,    /* The P4 operand */
      |   ~~~~~~~~~~~~^~~
./sqlite3.cpp:113026:23: warning: invalid conversion from ‘void*’ to ‘const char*’ [-fpermissive]
113026 |                       (void*)pColl, P4_COLLSEQ);
       |                       ^~~~~~~~~~~~
       |                       |
       |                       void*
./sqlite3.cpp:85248:15: note:   initializing argument 6 of ‘int sqlite3VdbeAddOp4(Vdbe*, int, int, int, int, const char*, int)’
85248 |   const char *zP4,    /* The P4 operand */
      |   ~~~~~~~~~~~~^~~
./sqlite3.cpp: In function ‘int sqlite3ExprCodeTarget(Parse*, Expr*, int)’:
./sqlite3.cpp:113741:31: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
113741 |       zBlob = sqlite3HexToBlob(sqlite3VdbeDb(v), z, n);
       |               ~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~
       |                               |
       |                               void*
./sqlite3.cpp: In function ‘int selectRefEnter(Walker*, Select*)’:
./sqlite3.cpp:115572:27: warning: invalid conversion from ‘void*’ to ‘int*’ [-fpermissive]
115572 |   piNew = sqlite3DbRealloc(p->db, p->aiExclude, p->nExclude*sizeof(int));
       |           ~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                           |
       |                           void*
./sqlite3.cpp: In function ‘int addAggInfoColumn(sqlite3*, AggInfo*)’:
./sqlite3.cpp:115735:37: warning: invalid conversion from ‘void*’ to ‘AggInfo_col*’ [-fpermissive]
115735 |   pInfo->aCol = sqlite3ArrayAllocate(
       |                 ~~~~~~~~~~~~~~~~~~~~^
       |                                     |
       |                                     void*
115736 |        db,
       |        ~~~
115737 |        pInfo->aCol,
       |        ~~~~~~~~~~~~
115738 |        sizeof(pInfo->aCol[0]),
       |        ~~~~~~~~~~~~~~~~~~~~~~~
115739 |        &pInfo->nColumn,
       |        ~~~~~~~~~~~~~~~~
115740 |        &i
       |        ~~
115741 |   );
       |   ~
./sqlite3.cpp: In function ‘int addAggInfoFunc(sqlite3*, AggInfo*)’:
./sqlite3.cpp:115751:38: warning: invalid conversion from ‘void*’ to ‘AggInfo_func*’ [-fpermissive]
115751 |   pInfo->aFunc = sqlite3ArrayAllocate(
       |                  ~~~~~~~~~~~~~~~~~~~~^
       |                                      |
       |                                      void*
115752 |        db,
       |        ~~~
115753 |        pInfo->aFunc,
       |        ~~~~~~~~~~~~~
115754 |        sizeof(pInfo->aFunc[0]),
       |        ~~~~~~~~~~~~~~~~~~~~~~~~
115755 |        &pInfo->nFunc,
       |        ~~~~~~~~~~~~~~
115756 |        &i
       |        ~~
115757 |   );
       |   ~
./sqlite3.cpp: In function ‘const void* sqlite3RenameTokenMap(Parse*, const void*, const Token*)’:
./sqlite3.cpp:116930:31: warning: invalid conversion from ‘void*’ to ‘RenameToken*’ [-fpermissive]
116930 |     pNew = sqlite3DbMallocZero(pParse->db, sizeof(RenameToken));
       |            ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                               |
       |                               void*
./sqlite3.cpp: In function ‘int renameEditSql(sqlite3_context*, RenameCtx*, const char*, const char*, int)’:
./sqlite3.cpp:117363:31: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
117363 |     zOut = sqlite3DbMallocZero(db, nSql + pRename->nList*nQuot + 1);
       |            ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                               |
       |                               void*
./sqlite3.cpp: In function ‘void statInit(sqlite3_context*, int, sqlite3_value**)’:
./sqlite3.cpp:118896:26: warning: invalid conversion from ‘void*’ to ‘StatAccum*’ [-fpermissive]
118896 |   p = sqlite3DbMallocZero(db, n);
       |       ~~~~~~~~~~~~~~~~~~~^~~~~~~
       |                          |
       |                          void*
./sqlite3.cpp: In function ‘void analyzeOneTable(Parse*, Table*, Index*, int, int, int)’:
./sqlite3.cpp:119626:39: warning: invalid conversion from ‘void*’ to ‘int*’ [-fpermissive]
119626 |       aGotoChng = sqlite3DbMallocRawNN(db, sizeof(int)*nColTest);
       |                   ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                       |
       |                                       void*
./sqlite3.cpp: In function ‘int sqlite3AnalysisLoad(sqlite3*, int)’:
./sqlite3.cpp:14460:35: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
14460 | #define sqliteHashData(E)   ((E)->data)
      |                             ~~~~~~^~~~~
      |                                   |
      |                                   void*
./sqlite3.cpp:120421:19: note: in expansion of macro ‘sqliteHashData’
120421 |     Table *pTab = sqliteHashData(i);
       |                   ^~~~~~~~~~~~~~
./sqlite3.cpp:14460:35: warning: invalid conversion from ‘void*’ to ‘Index*’ [-fpermissive]
14460 | #define sqliteHashData(E)   ((E)->data)
      |                             ~~~~~~^~~~~
      |                                   |
      |                                   void*
./sqlite3.cpp:120425:19: note: in expansion of macro ‘sqliteHashData’
120425 |     Index *pIdx = sqliteHashData(i);
       |                   ^~~~~~~~~~~~~~
./sqlite3.cpp:14460:35: warning: invalid conversion from ‘void*’ to ‘Index*’ [-fpermissive]
14460 | #define sqliteHashData(E)   ((E)->data)
      |                             ~~~~~~^~~~~
      |                                   |
      |                                   void*
./sqlite3.cpp:120452:19: note: in expansion of macro ‘sqliteHashData’
120452 |     Index *pIdx = sqliteHashData(i);
       |                   ^~~~~~~~~~~~~~
./sqlite3.cpp: In function ‘void attachFunc(sqlite3_context*, int, sqlite3_value**)’:
./sqlite3.cpp:120635:34: warning: invalid conversion from ‘void*’ to ‘Db*’ [-fpermissive]
120635 |       aNew = sqlite3DbMallocRawNN(db, sizeof(db->aDb[0])*3 );
       |              ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                  |
       |                                  void*
./sqlite3.cpp:120639:30: warning: invalid conversion from ‘void*’ to ‘Db*’ [-fpermissive]
120639 |       aNew = sqlite3DbRealloc(db, db->aDb, sizeof(db->aDb[0])*(db->nDb+1) );
       |              ~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                              |
       |                              void*
./sqlite3.cpp: In function ‘void lockTable(Parse*, int, Pgno, u8, const char*)’:
./sqlite3.cpp:121444:29: warning: invalid conversion from ‘void*’ to ‘TableLock*’ [-fpermissive]
121444 |       sqlite3DbReallocOrFree(pToplevel->db, pToplevel->aTableLock, nBytes);
       |       ~~~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                             |
       |                             void*
./sqlite3.cpp: In function ‘Table* sqlite3FindTable(sqlite3*, const char*, const char*)’:
./sqlite3.cpp:121750:24: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
121750 |     p = sqlite3HashFind(&db->aDb[i].pSchema->tblHash, zName);
       |         ~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                        |
       |                        void*
./sqlite3.cpp:121757:30: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
121757 |           p = sqlite3HashFind(&db->aDb[1].pSchema->tblHash,
       |               ~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                              |
       |                              void*
121758 |                               LEGACY_TEMP_SCHEMA_TABLE);
       |                               ~~~~~~~~~~~~~~~~~~~~~~~~~
./sqlite3.cpp:121762:30: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
121762 |           p = sqlite3HashFind(&db->aDb[i].pSchema->tblHash,
       |               ~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                              |
       |                              void*
121763 |                               LEGACY_SCHEMA_TABLE);
       |                               ~~~~~~~~~~~~~~~~~~~~
./sqlite3.cpp:121769:24: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
121769 |     p = sqlite3HashFind(&db->aDb[1].pSchema->tblHash, zName);
       |         ~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                        |
       |                        void*
./sqlite3.cpp:121772:24: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
121772 |     p = sqlite3HashFind(&db->aDb[0].pSchema->tblHash, zName);
       |         ~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                        |
       |                        void*
./sqlite3.cpp:121777:26: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
121777 |       p = sqlite3HashFind(&db->aDb[i].pSchema->tblHash, zName);
       |           ~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                          |
       |                          void*
./sqlite3.cpp:121782:28: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
121782 |         p = sqlite3HashFind(&db->aDb[0].pSchema->tblHash, LEGACY_SCHEMA_TABLE);
       |             ~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                            |
       |                            void*
./sqlite3.cpp:121784:28: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
121784 |         p = sqlite3HashFind(&db->aDb[1].pSchema->tblHash,
       |             ~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                            |
       |                            void*
121785 |                             LEGACY_TEMP_SCHEMA_TABLE);
       |                             ~~~~~~~~~~~~~~~~~~~~~~~~~
./sqlite3.cpp: In function ‘Index* sqlite3FindIndex(sqlite3*, const char*, const char*)’:
./sqlite3.cpp:121920:24: warning: invalid conversion from ‘void*’ to ‘Index*’ [-fpermissive]
121920 |     p = sqlite3HashFind(&pSchema->idxHash, zName);
       |         ~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~
       |                        |
       |                        void*
./sqlite3.cpp: In function ‘void sqlite3UnlinkAndDeleteIndex(sqlite3*, int, const char*)’:
./sqlite3.cpp:121955:29: warning: invalid conversion from ‘void*’ to ‘Index*’ [-fpermissive]
121955 |   pIndex = sqlite3HashInsert(pHash, zIdxName, 0);
       |            ~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~
       |                             |
       |                             void*
./sqlite3.cpp: In function ‘void sqlite3ColumnSetColl(sqlite3*, Column*, const char*)’:
./sqlite3.cpp:122117:26: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
122117 |   zNew = sqlite3DbRealloc(db, pCol->zCnName, nColl+n);
       |          ~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                          |
       |                          void*
./sqlite3.cpp: In function ‘void sqlite3UnlinkAndDeleteTable(sqlite3*, int, const char*)’:
./sqlite3.cpp:122266:24: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
122266 |   p = sqlite3HashInsert(&pDb->pSchema->tblHash, zTabName, 0);
       |       ~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                        |
       |                        void*
./sqlite3.cpp: In function ‘void sqlite3StartTable(Parse*, Token*, Token*, int, int, int, int)’:
./sqlite3.cpp:122677:31: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
122677 |   pTable = sqlite3DbMallocZero(db, sizeof(Table));
       |            ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~
       |                               |
       |                               void*
./sqlite3.cpp: In function ‘void sqlite3AddReturning(Parse*, ExprList*)’:
./sqlite3.cpp:122822:29: warning: invalid conversion from ‘void*’ to ‘Returning*’ [-fpermissive]
122822 |   pRet = sqlite3DbMallocZero(db, sizeof(*pRet));
       |          ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~
       |                             |
       |                             void*
./sqlite3.cpp: In function ‘void sqlite3AddColumn(Parse*, Token, Token)’:
./sqlite3.cpp:122917:25: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
122917 |   z = sqlite3DbMallocRaw(db, (i64)sName.n + 1 + (i64)sType.n + (sType.n>0) );
       |       ~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                         |
       |                         void*
./sqlite3.cpp:122931:26: warning: invalid conversion from ‘void*’ to ‘Column*’ [-fpermissive]
122931 |   aNew = sqlite3DbRealloc(db,p->aCol,((i64)p->nCol+1)*sizeof(p->aCol[0]));
       |          ~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                          |
       |                          void*
./sqlite3.cpp: In function ‘char* createTableStmt(sqlite3*, Table*)’:
./sqlite3.cpp:123496:12: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
123496 |     zSep = "";
       |            ^~
./sqlite3.cpp:123497:13: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
123497 |     zSep2 = ",";
       |             ^~~
./sqlite3.cpp:123498:12: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
123498 |     zEnd = ")";
       |            ^~~
./sqlite3.cpp:123500:12: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
123500 |     zSep = "\n  ";
       |            ^~~~~~
./sqlite3.cpp:123501:13: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
123501 |     zSep2 = ",\n  ";
       |             ^~~~~~~
./sqlite3.cpp:123502:12: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
123502 |     zEnd = "\n)";
       |            ^~~~~
./sqlite3.cpp:123505:29: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
123505 |   zStmt = sqlite3DbMallocRaw(0, n);
       |           ~~~~~~~~~~~~~~~~~~^~~~~~
       |                             |
       |                             void*
./sqlite3.cpp: In function ‘int resizeIndexObject(sqlite3*, Index*, int)’:
./sqlite3.cpp:123562:31: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
123562 |   zExtra = sqlite3DbMallocZero(db, nByte);
       |            ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~
       |                               |
       |                               void*
./sqlite3.cpp: In function ‘void sqlite3MarkAllShadowTablesOf(sqlite3*, Table*)’:
./sqlite3.cpp:14460:35: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
14460 | #define sqliteHashData(E)   ((E)->data)
      |                             ~~~~~~^~~~~
      |                                   |
      |                                   void*
./sqlite3.cpp:123912:21: note: in expansion of macro ‘sqliteHashData’
123912 |     Table *pOther = sqliteHashData(k);
       |                     ^~~~~~~~~~~~~~
./sqlite3.cpp: In function ‘int sqlite3ShadowTableName(sqlite3*, const char*)’:
./sqlite3.cpp:123937:18: warning: invalid conversion from ‘const char*’ to ‘char*’ [-fpermissive]
123937 |   zTail = strrchr(zName, '_');
       |           ~~~~~~~^~~~~~~~~~~~
       |                  |
       |                  const char*
./sqlite3.cpp: In function ‘void sqlite3EndTable(Parse*, Token*, Token*, u32, Select*)’:
./sqlite3.cpp:124054:62: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
124054 |             p->zName, pCol->zCnName, sqlite3ColumnType(pCol, "")
       |                                                              ^~
./sqlite3.cpp:124171:15: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
124171 |       zType = "table";
       |               ^~~~~~~
./sqlite3.cpp:124172:16: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
124172 |       zType2 = "TABLE";
       |                ^~~~~~~
./sqlite3.cpp:124176:15: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
124176 |       zType = "view";
       |               ^~~~~~
./sqlite3.cpp:124177:16: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
124177 |       zType2 = "VIEW";
       |                ^~~~~~
./sqlite3.cpp:124310:29: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
124310 |     pOld = sqlite3HashInsert(&pSchema->tblHash, p->zName, p);
       |            ~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                             |
       |                             void*
./sqlite3.cpp: In function ‘void sqliteViewResetAll(sqlite3*, int)’:
./sqlite3.cpp:14460:35: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
14460 | #define sqliteHashData(E)   ((E)->data)
      |                             ~~~~~~^~~~~
      |                                   |
      |                                   void*
./sqlite3.cpp:124580:19: note: in expansion of macro ‘sqliteHashData’
124580 |     Table *pTab = sqliteHashData(i);
       |                   ^~~~~~~~~~~~~~
./sqlite3.cpp: In function ‘void sqlite3RootPageMoved(sqlite3*, int, Pgno, Pgno)’:
./sqlite3.cpp:14460:35: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
14460 | #define sqliteHashData(E)   ((E)->data)
      |                             ~~~~~~^~~~~
      |                                   |
      |                                   void*
./sqlite3.cpp:124618:19: note: in expansion of macro ‘sqliteHashData’
124618 |     Table *pTab = sqliteHashData(pElem);
       |                   ^~~~~~~~~~~~~~
./sqlite3.cpp:14460:35: warning: invalid conversion from ‘void*’ to ‘Index*’ [-fpermissive]
14460 | #define sqliteHashData(E)   ((E)->data)
      |                             ~~~~~~^~~~~
      |                                   |
      |                                   void*
./sqlite3.cpp:124625:19: note: in expansion of macro ‘sqliteHashData’
124625 |     Index *pIdx = sqliteHashData(pElem);
       |                   ^~~~~~~~~~~~~~
./sqlite3.cpp: In function ‘void sqlite3CreateForeignKey(Parse*, ExprList*, Token*, ExprList*, int)’:
./sqlite3.cpp:125012:30: warning: invalid conversion from ‘void*’ to ‘FKey*’ [-fpermissive]
125012 |   pFKey = sqlite3DbMallocZero(db, nByte );
       |           ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~
       |                              |
       |                              void*
./sqlite3.cpp: In function ‘Index* sqlite3AllocateIndexObject(sqlite3*, i16, int, char**)’:
./sqlite3.cpp:125244:26: warning: invalid conversion from ‘void*’ to ‘Index*’ [-fpermissive]
125244 |   p = sqlite3DbMallocZero(db, nByte + nExtra);
       |       ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~
       |                          |
       |                          void*
./sqlite3.cpp: In function ‘void sqlite3CreateIndex(Parse*, Token*, Token*, SrcList*, ExprList*, int, Token*, Expr*, int, int, u8)’:
./sqlite3.cpp:125753:28: warning: invalid conversion from ‘void*’ to ‘Index*’ [-fpermissive]
125753 |       p = sqlite3HashInsert(&pIndex->pSchema->idxHash,
       |           ~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                            |
       |                            void*
125754 |           pIndex->zName, pIndex);
       |           ~~~~~~~~~~~~~~~~~~~~~~
./sqlite3.cpp: In function ‘IdList* sqlite3IdListAppend(Parse*, IdList*, Token*)’:
./sqlite3.cpp:126064:32: warning: invalid conversion from ‘void*’ to ‘IdList*’ [-fpermissive]
126064 |     pList = sqlite3DbMallocZero(db, sizeof(IdList) );
       |             ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~
       |                                |
       |                                void*
./sqlite3.cpp:126068:28: warning: invalid conversion from ‘void*’ to ‘IdList*’ [-fpermissive]
126068 |     pNew = sqlite3DbRealloc(db, pList,
       |            ~~~~~~~~~~~~~~~~^~~~~~~~~~~
       |                            |
       |                            void*
126069 |                  sizeof(IdList) + pList->nId*sizeof(pList->a));
       |                  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
./sqlite3.cpp: In function ‘SrcList* sqlite3SrcListEnlarge(Parse*, SrcList*, int, int)’:
./sqlite3.cpp:126169:28: warning: invalid conversion from ‘void*’ to ‘SrcList*’ [-fpermissive]
126169 |     pNew = sqlite3DbRealloc(db, pSrc,
       |            ~~~~~~~~~~~~~~~~^~~~~~~~~~
       |                            |
       |                            void*
126170 |                sizeof(*pSrc) + (nAlloc-1)*sizeof(pSrc->a[0]) );
       |                ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
./sqlite3.cpp: In function ‘SrcList* sqlite3SrcListAppend(Parse*, SrcList*, Token*, Token*)’:
./sqlite3.cpp:126245:33: warning: invalid conversion from ‘void*’ to ‘SrcList*’ [-fpermissive]
126245 |     pList = sqlite3DbMallocRawNN(pParse->db, sizeof(SrcList) );
       |             ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                 |
       |                                 void*
./sqlite3.cpp: In function ‘Cte* sqlite3CteNew(Parse*, Token*, ExprList*, Select*, u8)’:
./sqlite3.cpp:126974:29: warning: invalid conversion from ‘void*’ to ‘Cte*’ [-fpermissive]
126974 |   pNew = sqlite3DbMallocZero(db, sizeof(*pNew));
       |          ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~
       |                             |
       |                             void*
./sqlite3.cpp: In function ‘With* sqlite3WithAdd(Parse*, With*, Cte*)’:
./sqlite3.cpp:127042:28: warning: invalid conversion from ‘void*’ to ‘With*’ [-fpermissive]
127042 |     pNew = sqlite3DbRealloc(db, pWith, nByte);
       |            ~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~
       |                            |
       |                            void*
./sqlite3.cpp:127044:31: warning: invalid conversion from ‘void*’ to ‘With*’ [-fpermissive]
127044 |     pNew = sqlite3DbMallocZero(db, sizeof(*pWith));
       |            ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~
       |                               |
       |                               void*
./sqlite3.cpp: In function ‘void callCollNeeded(sqlite3*, int, const char*)’:
./sqlite3.cpp:127113:33: warning: invalid conversion from ‘const void*’ to ‘const char*’ [-fpermissive]
127113 |     zExternal = sqlite3ValueText(pTmp, SQLITE_UTF16NATIVE);
       |                 ~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                 |
       |                                 const void*
./sqlite3.cpp: In function ‘CollSeq* findCollSeqEntry(sqlite3*, const char*, int)’:
./sqlite3.cpp:127190:26: warning: invalid conversion from ‘void*’ to ‘CollSeq*’ [-fpermissive]
127190 |   pColl = sqlite3HashFind(&db->aCollSeq, zName);
       |           ~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~
       |                          |
       |                          void*
./sqlite3.cpp:127194:32: warning: invalid conversion from ‘void*’ to ‘CollSeq*’ [-fpermissive]
127194 |     pColl = sqlite3DbMallocZero(db, 3*sizeof(*pColl) + nName);
       |             ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                |
       |                                void*
./sqlite3.cpp:127204:31: warning: invalid conversion from ‘void*’ to ‘CollSeq*’ [-fpermissive]
127204 |       pDel = sqlite3HashInsert(&db->aCollSeq, pColl[0].zName, pColl);
       |              ~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                               |
       |                               void*
./sqlite3.cpp: In function ‘FuncDef* sqlite3FindFunction(sqlite3*, const char*, int, u8, u8)’:
./sqlite3.cpp:127534:35: warning: invalid conversion from ‘void*’ to ‘FuncDef*’ [-fpermissive]
127534 |       (pBest = sqlite3DbMallocZero(db, sizeof(*pBest)+nName+1))!=0 ){
       |                ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                   |
       |                                   void*
./sqlite3.cpp: In function ‘void sqlite3SchemaClear(void*)’:
./sqlite3.cpp:14460:35: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
14460 | #define sqliteHashData(E)   ((E)->data)
      |                             ~~~~~~^~~~~
      |                                   |
      |                                   void*
./sqlite3.cpp:127584:19: note: in expansion of macro ‘sqliteHashData’
127584 |     Table *pTab = sqliteHashData(pElem);
       |                   ^~~~~~~~~~~~~~
./sqlite3.cpp: In function ‘void sqlite3DeleteFrom(Parse*, SrcList*, Expr*, ExprList*, Expr*)’:
./sqlite3.cpp:128178:37: warning: invalid conversion from ‘void*’ to ‘u8*’ {aka ‘unsigned char*’} [-fpermissive]
128178 |       aToOpen = sqlite3DbMallocRawNN(db, nIdx+2);
       |                 ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~
       |                                     |
       |                                     void*
./sqlite3.cpp: In function ‘void instrFunc(sqlite3_context*, int, sqlite3_value**)’:
./sqlite3.cpp:128918:37: warning: invalid conversion from ‘const void*’ to ‘const unsigned char*’ [-fpermissive]
128918 |       zHaystack = sqlite3_value_blob(argv[0]);
       |                   ~~~~~~~~~~~~~~~~~~^~~~~~~~~
       |                                     |
       |                                     const void*
./sqlite3.cpp:128919:35: warning: invalid conversion from ‘const void*’ to ‘const unsigned char*’ [-fpermissive]
128919 |       zNeedle = sqlite3_value_blob(argv[1]);
       |                 ~~~~~~~~~~~~~~~~~~^~~~~~~~~
       |                                   |
       |                                   const void*
./sqlite3.cpp: In function ‘void substrFunc(sqlite3_context*, int, sqlite3_value**)’:
./sqlite3.cpp:129020:27: warning: invalid conversion from ‘const void*’ to ‘const unsigned char*’ [-fpermissive]
129020 |     z = sqlite3_value_blob(argv[0]);
       |         ~~~~~~~~~~~~~~~~~~^~~~~~~~~
       |                           |
       |                           const void*
./sqlite3.cpp: In function ‘void* contextMalloc(sqlite3_context*, i64)’:
./sqlite3.cpp:129144:22: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
129144 |     z = sqlite3Malloc(nByte);
       |         ~~~~~~~~~~~~~^~~~~~~
       |                      |
       |                      void*
./sqlite3.cpp: In function ‘void upperFunc(sqlite3_context*, int, sqlite3_value**)’:
./sqlite3.cpp:129165:23: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
129165 |     z1 = contextMalloc(context, ((i64)n)+1);
       |          ~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~
       |                       |
       |                       void*
./sqlite3.cpp: In function ‘void lowerFunc(sqlite3_context*, int, sqlite3_value**)’:
./sqlite3.cpp:129184:23: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
129184 |     z1 = contextMalloc(context, ((i64)n)+1);
       |          ~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~
       |                       |
       |                       void*
./sqlite3.cpp: In function ‘void randomBlob(sqlite3_context*, int, sqlite3_value**)’:
./sqlite3.cpp:129246:20: warning: invalid conversion from ‘void*’ to ‘unsigned char*’ [-fpermissive]
129246 |   p = contextMalloc(context, n);
       |       ~~~~~~~~~~~~~^~~~~~~~~~~~
       |                    |
       |                    void*
./sqlite3.cpp: In function ‘void likeFunc(sqlite3_context*, int, sqlite3_value**)’:
./sqlite3.cpp:129567:48: warning: invalid conversion from ‘void*’ to ‘compareInfo*’ [-fpermissive]
129567 |   struct compareInfo *pInfo = sqlite3_user_data(context);
       |                               ~~~~~~~~~~~~~~~~~^~~~~~~~~
       |                                                |
       |                                                void*
./sqlite3.cpp: In function ‘void sqlite3QuoteValue(StrAccum*, sqlite3_value*)’:
./sqlite3.cpp:129771:45: warning: invalid conversion from ‘const void*’ to ‘const char*’ [-fpermissive]
129771 |       char const *zBlob = sqlite3_value_blob(pValue);
       |                           ~~~~~~~~~~~~~~~~~~^~~~~~~~
       |                                             |
       |                                             const void*
./sqlite3.cpp: In function ‘void charFunc(sqlite3_context*, int, sqlite3_value**)’:
./sqlite3.cpp:129854:30: warning: invalid conversion from ‘void*’ to ‘unsigned char*’ [-fpermissive]
129854 |   zOut = z = sqlite3_malloc64( argc*4+1 );
       |              ~~~~~~~~~~~~~~~~^~~~~~~~~~~~
       |                              |
       |                              void*
./sqlite3.cpp: In function ‘void hexFunc(sqlite3_context*, int, sqlite3_value**)’:
./sqlite3.cpp:129899:29: warning: invalid conversion from ‘const void*’ to ‘const unsigned char*’ [-fpermissive]
129899 |   pBlob = sqlite3_value_blob(argv[0]);
       |           ~~~~~~~~~~~~~~~~~~^~~~~~~~~
       |                             |
       |                             const void*
./sqlite3.cpp:129902:27: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
129902 |   z = zHex = contextMalloc(context, ((i64)n)*2 + 1);
       |              ~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~
       |                           |
       |                           void*
./sqlite3.cpp: In function ‘void unhexFunc(sqlite3_context*, int, sqlite3_value**)’:
./sqlite3.cpp:129973:28: warning: invalid conversion from ‘void*’ to ‘u8*’ {aka ‘unsigned char*’} [-fpermissive]
129973 |   p = pBlob = contextMalloc(pCtx, (nHex/2)+1);
       |               ~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~
       |                            |
       |                            void*
./sqlite3.cpp: In function ‘void replaceFunc(sqlite3_context*, int, sqlite3_value**)’:
./sqlite3.cpp:130074:23: warning: invalid conversion from ‘void*’ to ‘unsigned char*’ [-fpermissive]
130074 |   zOut = contextMalloc(context, (i64)nOut);
       |          ~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~
       |                       |
       |                       void*
./sqlite3.cpp:130099:32: warning: invalid conversion from ‘void*’ to ‘unsigned char*’ [-fpermissive]
130099 |           zOut = sqlite3Realloc(zOut, (int)nOut + (nOut - nStr - 1));
       |                  ~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                |
       |                                void*
./sqlite3.cpp: In function ‘void trimFunc(sqlite3_context*, int, sqlite3_value**)’:
./sqlite3.cpp:130160:29: warning: invalid conversion from ‘void*’ to ‘unsigned char**’ [-fpermissive]
130160 |       azChar = contextMalloc(context,
       |                ~~~~~~~~~~~~~^~~~~~~~~
       |                             |
       |                             void*
130161 |                      ((i64)nChar)*(sizeof(char*)+sizeof(unsigned)));
       |                      ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
./sqlite3.cpp: In function ‘void concatFuncCore(sqlite3_context*, int, sqlite3_value**, int, const char*)’:
./sqlite3.cpp:130225:23: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
130225 |   z = sqlite3_malloc64(n+1);
       |       ~~~~~~~~~~~~~~~~^~~~~
       |                       |
       |                       void*
./sqlite3.cpp: In function ‘void sumStep(sqlite3_context*, int, sqlite3_value**)’:
./sqlite3.cpp:130478:32: warning: invalid conversion from ‘void*’ to ‘SumCtx*’ [-fpermissive]
130478 |   p = sqlite3_aggregate_context(context, sizeof(*p));
       |       ~~~~~~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~
       |                                |
       |                                void*
./sqlite3.cpp: In function ‘void sumInverse(sqlite3_context*, int, sqlite3_value**)’:
./sqlite3.cpp:130514:32: warning: invalid conversion from ‘void*’ to ‘SumCtx*’ [-fpermissive]
130514 |   p = sqlite3_aggregate_context(context, sizeof(*p));
       |       ~~~~~~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~
       |                                |
       |                                void*
./sqlite3.cpp: In function ‘void sumFinalize(sqlite3_context*)’:
./sqlite3.cpp:130541:32: warning: invalid conversion from ‘void*’ to ‘SumCtx*’ [-fpermissive]
130541 |   p = sqlite3_aggregate_context(context, 0);
       |       ~~~~~~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~
       |                                |
       |                                void*
./sqlite3.cpp: In function ‘void avgFinalize(sqlite3_context*)’:
./sqlite3.cpp:130558:32: warning: invalid conversion from ‘void*’ to ‘SumCtx*’ [-fpermissive]
130558 |   p = sqlite3_aggregate_context(context, 0);
       |       ~~~~~~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~
       |                                |
       |                                void*
./sqlite3.cpp: In function ‘void totalFinalize(sqlite3_context*)’:
./sqlite3.cpp:130573:32: warning: invalid conversion from ‘void*’ to ‘SumCtx*’ [-fpermissive]
130573 |   p = sqlite3_aggregate_context(context, 0);
       |       ~~~~~~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~
       |                                |
       |                                void*
./sqlite3.cpp: In function ‘void countStep(sqlite3_context*, int, sqlite3_value**)’:
./sqlite3.cpp:130602:32: warning: invalid conversion from ‘void*’ to ‘CountCtx*’ [-fpermissive]
130602 |   p = sqlite3_aggregate_context(context, sizeof(*p));
       |       ~~~~~~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~
       |                                |
       |                                void*
./sqlite3.cpp: In function ‘void countFinalize(sqlite3_context*)’:
./sqlite3.cpp:130618:32: warning: invalid conversion from ‘void*’ to ‘CountCtx*’ [-fpermissive]
130618 |   p = sqlite3_aggregate_context(context, 0);
       |       ~~~~~~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~
       |                                |
       |                                void*
./sqlite3.cpp: In function ‘void countInverse(sqlite3_context*, int, sqlite3_value**)’:
./sqlite3.cpp:130624:32: warning: invalid conversion from ‘void*’ to ‘CountCtx*’ [-fpermissive]
130624 |   p = sqlite3_aggregate_context(ctx, sizeof(*p));
       |       ~~~~~~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~
       |                                |
       |                                void*
./sqlite3.cpp: In function ‘void sqlite3FkClearTriggerCache(sqlite3*, int)’:
./sqlite3.cpp:14460:35: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
14460 | #define sqliteHashData(E)   ((E)->data)
      |                             ~~~~~~^~~~~
      |                                   |
      |                                   void*
./sqlite3.cpp:132117:19: note: in expansion of macro ‘sqliteHashData’
132117 |     Table *pTab = sqliteHashData(k);
       |                   ^~~~~~~~~~~~~~
./sqlite3.cpp: In function ‘int autoIncBegin(Parse*, int, Table*)’:
./sqlite3.cpp:133330:35: warning: invalid conversion from ‘void*’ to ‘AutoincInfo*’ [-fpermissive]
133330 |       pInfo = sqlite3DbMallocRawNN(pParse->db, sizeof(*pInfo));
       |               ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                   |
       |                                   void*
./sqlite3.cpp: In function ‘void sqlite3Insert(Parse*, SrcList*, Select*, IdList*, int, Upsert*)’:
./sqlite3.cpp:134153:35: warning: invalid conversion from ‘void*’ to ‘int*’ [-fpermissive]
134153 |     aRegIdx = sqlite3DbMallocRawNN(db, sizeof(int)*(nIdx+2));
       |               ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                   |
       |                                   void*
./sqlite3.cpp: In function ‘void sqlite3GenerateConstraintChecks(Parse*, Table*, int*, int, int, int, int, u8, u8, int, int*, int*, Upsert*)’:
./sqlite3.cpp:135038:47: warning: invalid conversion from ‘void*’ to ‘IndexListTerm*’ [-fpermissive]
135038 |       sIdxIter.u.ax.aIdx = sqlite3DbMallocZero(db, nByte);
       |                            ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~
       |                                               |
       |                                               void*
./sqlite3.cpp:135527:40: warning: invalid conversion from ‘void*’ to ‘const char*’ [-fpermissive]
135527 |               zP4 = x.p4type==P4_INT32 ? SQLITE_INT_TO_PTR(x.p4.i) : x.p4.z;
       |                     ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                        |
       |                                        void*
./sqlite3.cpp: In function ‘int sqlite3_exec(sqlite3*, const char*, sqlite3_callback, void*, char**)’:
./sqlite3.cpp:136344:38: warning: invalid conversion from ‘void*’ to ‘char**’ [-fpermissive]
136344 |           azCols = sqlite3DbMallocRaw(db, (2*nCol+1)*sizeof(const char*));
       |                    ~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                      |
       |                                      void*
./sqlite3.cpp: In function ‘int sqlite3LoadExtension(sqlite3*, const char*, const char*, char**)’:
./sqlite3.cpp:137768:33: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
137768 |     zAltEntry = sqlite3_malloc64(ncFile+30);
       |                 ~~~~~~~~~~~~~~~~^~~~~~~~~~~
       |                                 |
       |                                 void*
./sqlite3.cpp:137789:45: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
137789 |       *pzErrMsg = zErrmsg = sqlite3_malloc64(nMsg);
       |                             ~~~~~~~~~~~~~~~~^~~~~~
       |                                             |
       |                                             void*
./sqlite3.cpp:137814:32: warning: invalid conversion from ‘void*’ to ‘void**’ [-fpermissive]
137814 |   aHandle = sqlite3DbMallocZero(db, sizeof(handle)*(db->nExtension+1));
       |             ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                |
       |                                void*
./sqlite3.cpp:137830:43: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
137830 |     *pzErrMsg = zErrmsg = sqlite3_malloc64(nMsg);
       |                           ~~~~~~~~~~~~~~~~^~~~~~
       |                                           |
       |                                           void*
./sqlite3.cpp: In function ‘int sqlite3_auto_extension(void (*)())’:
./sqlite3.cpp:137946:31: warning: invalid conversion from ‘void*’ to ‘void (**)()’ [-fpermissive]
137946 |       aNew = sqlite3_realloc64(wsdAutoext.aExt, nByte);
       |              ~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~
       |                               |
       |                               void*
./sqlite3.cpp: In function ‘const char* sqlite3JournalModename(int)’:
./sqlite3.cpp:139015:5: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
139015 |     "delete", "persist", "off", "truncate", "memory"
       |     ^~~~~~~~
./sqlite3.cpp:139015:15: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
139015 |     "delete", "persist", "off", "truncate", "memory"
       |               ^~~~~~~~~
./sqlite3.cpp:139015:26: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
139015 |     "delete", "persist", "off", "truncate", "memory"
       |                          ^~~~~
./sqlite3.cpp:139015:33: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
139015 |     "delete", "persist", "off", "truncate", "memory"
       |                                 ^~~~~~~~~~
./sqlite3.cpp:139015:45: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
139015 |     "delete", "persist", "off", "truncate", "memory"
       |                                             ^~~~~~~~
./sqlite3.cpp:139017:8: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
139017 |      , "wal"
       |        ^~~~~
./sqlite3.cpp: In function ‘void sqlite3Pragma(Parse*, Token*, Token*, Token*, int)’:
./sqlite3.cpp:139963:39: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
139963 |                sqlite3ColumnType(pCol,""),
       |                                       ^~
./sqlite3.cpp:14460:35: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
14460 | #define sqliteHashData(E)   ((E)->data)
      |                             ~~~~~~^~~~~
      |                                   |
      |                                   void*
./sqlite3.cpp:140007:18: note: in expansion of macro ‘sqliteHashData’
140007 |           pTab = sqliteHashData(k);
       |                  ^~~~~~~~~~~~~~
./sqlite3.cpp:14460:35: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
14460 | #define sqliteHashData(E)   ((E)->data)
      |                             ~~~~~~^~~~~
      |                                   |
      |                                   void*
./sqlite3.cpp:140027:23: note: in expansion of macro ‘sqliteHashData’
140027 |         Table *pTab = sqliteHashData(k);
       |                       ^~~~~~~~~~~~~~
./sqlite3.cpp:14460:35: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
14460 | #define sqliteHashData(E)   ((E)->data)
      |                             ~~~~~~^~~~~
      |                                   |
      |                                   void*
./sqlite3.cpp:140462:23: note: in expansion of macro ‘sqliteHashData’
140462 |         Table *pTab = sqliteHashData(x);  /* Current table */
       |                       ^~~~~~~~~~~~~~
./sqlite3.cpp:140471:35: warning: invalid conversion from ‘void*’ to ‘int*’ [-fpermissive]
140471 |       aRoot = sqlite3DbMallocRawNN(db, sizeof(int)*(cnt+1));
       |               ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~
       |                                   |
       |                                   void*
./sqlite3.cpp:14460:35: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
14460 | #define sqliteHashData(E)   ((E)->data)
      |                             ~~~~~~^~~~~
      |                                   |
      |                                   void*
./sqlite3.cpp:140476:23: note: in expansion of macro ‘sqliteHashData’
140476 |         Table *pTab = sqliteHashData(x);
       |                       ^~~~~~~~~~~~~~
./sqlite3.cpp:14460:35: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
14460 | #define sqliteHashData(E)   ((E)->data)
      |                             ~~~~~~^~~~~
      |                                   |
      |                                   void*
./sqlite3.cpp:140506:23: note: in expansion of macro ‘sqliteHashData’
140506 |         Table *pTab = sqliteHashData(x);
       |                       ^~~~~~~~~~~~~~
./sqlite3.cpp:14460:35: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
14460 | #define sqliteHashData(E)   ((E)->data)
      |                             ~~~~~~^~~~~
      |                                   |
      |                                   void*
./sqlite3.cpp:140534:23: note: in expansion of macro ‘sqliteHashData’
140534 |         Table *pTab = sqliteHashData(x);
       |                       ^~~~~~~~~~~~~~
./sqlite3.cpp:14460:35: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
14460 | #define sqliteHashData(E)   ((E)->data)
      |                             ~~~~~~^~~~~
      |                                   |
      |                                   void*
./sqlite3.cpp:140865:23: note: in expansion of macro ‘sqliteHashData’
140865 |         Table *pTab = sqliteHashData(x);
       |                       ^~~~~~~~~~~~~~
./sqlite3.cpp:140909:23: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
140909 |         aOp[2].p4.z = "ok";
       |                       ^~~~
./sqlite3.cpp:140947:9: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
140947 |       { "UTF8",     SQLITE_UTF8        },
       |         ^~~~~~
./sqlite3.cpp:140948:9: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
140948 |       { "UTF-8",    SQLITE_UTF8        },  /* Must be element [1] */
       |         ^~~~~~~
./sqlite3.cpp:140949:9: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
140949 |       { "UTF-16le", SQLITE_UTF16LE     },  /* Must be element [2] */
       |         ^~~~~~~~~~
./sqlite3.cpp:140950:9: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
140950 |       { "UTF-16be", SQLITE_UTF16BE     },  /* Must be element [3] */
       |         ^~~~~~~~~~
./sqlite3.cpp:140951:9: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
140951 |       { "UTF16le",  SQLITE_UTF16LE     },
       |         ^~~~~~~~~
./sqlite3.cpp:140952:9: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
140952 |       { "UTF16be",  SQLITE_UTF16BE     },
       |         ^~~~~~~~~
./sqlite3.cpp:140953:9: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
140953 |       { "UTF-16",   0                  }, /* SQLITE_UTF16NATIVE */
       |         ^~~~~~~~
./sqlite3.cpp:140954:9: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
140954 |       { "UTF16",    0                  }, /* SQLITE_UTF16NATIVE */
       |         ^~~~~~~
./sqlite3.cpp: In function ‘void* sqlite3ParserAddCleanup(Parse*, void (*)(sqlite3*, void*), void*)’:
./sqlite3.cpp:142444:34: warning: invalid conversion from ‘void*’ to ‘ParseCleanup*’ [-fpermissive]
142444 |     pCleanup = sqlite3DbMallocRaw(pParse->db, sizeof(*pCleanup));
       |                ~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                  |
       |                                  void*
./sqlite3.cpp: In function ‘Select* sqlite3SelectNew(Parse*, ExprList*, SrcList*, Expr*, ExprList*, Expr*, ExprList*, u32, Expr*)’:
./sqlite3.cpp:143030:43: warning: invalid conversion from ‘void*’ to ‘Select*’ [-fpermissive]
143030 |   pAllocated = pNew = sqlite3DbMallocRawNN(pParse->db, sizeof(*pNew) );
       |                       ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                           |
       |                                           void*
./sqlite3.cpp:143048:43: warning: invalid conversion from ‘void*’ to ‘SrcList*’ [-fpermissive]
143048 |   if( pSrc==0 ) pSrc = sqlite3DbMallocZero(pParse->db, sizeof(*pSrc));
       |                        ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                           |
       |                                           void*
./sqlite3.cpp: In function ‘KeyInfo* sqlite3KeyInfoAlloc(sqlite3*, int, int)’:
./sqlite3.cpp:144401:36: warning: invalid conversion from ‘void*’ to ‘KeyInfo*’ [-fpermissive]
144401 |   KeyInfo *p = sqlite3DbMallocRawNN(db, sizeof(KeyInfo) + nExtra);
       |                ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                    |
       |                                    void*
./sqlite3.cpp: In function ‘const char* sqlite3SelectOpName(int)’:
./sqlite3.cpp:144493:28: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
144493 |     case TK_ALL:       z = "UNION ALL";   break;
       |                            ^~~~~~~~~~~
./sqlite3.cpp:144494:28: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
144494 |     case TK_INTERSECT: z = "INTERSECT";   break;
       |                            ^~~~~~~~~~~
./sqlite3.cpp:144495:28: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
144495 |     case TK_EXCEPT:    z = "EXCEPT";      break;
       |                            ^~~~~~~~
./sqlite3.cpp:144496:28: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
144496 |     default:           z = "UNION";       break;
       |                            ^~~~~~~
./sqlite3.cpp: In function ‘void sqlite3GenerateColumnNames(Parse*, Select*)’:
./sqlite3.cpp:145042:16: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
145042 |         zCol = "rowid";
       |                ^~~~~~~
./sqlite3.cpp: In function ‘int sqlite3ColumnsFromExprList(Parse*, ExprList*, i16*, Column**)’:
./sqlite3.cpp:145103:31: warning: invalid conversion from ‘void*’ to ‘Column*’ [-fpermissive]
145103 |     aCol = sqlite3DbMallocZero(db, sizeof(aCol[0])*nCol);
       |            ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~
       |                               |
       |                               void*
./sqlite3.cpp:145135:25: warning: invalid conversion from ‘const char*’ to ‘char*’ [-fpermissive]
145135 |         zName = iCol>=0 ? pTab->aCol[iCol].zCnName : "rowid";
       |                 ~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                         |
       |                         const char*
./sqlite3.cpp:145154:48: warning: invalid conversion from ‘void*’ to ‘ExprList_item*’ [-fpermissive]
145154 |     while( zName && (pCollide = sqlite3HashFind(&ht, zName))!=0 ){
       |                                 ~~~~~~~~~~~~~~~^~~~~~~~~~~~
       |                                                |
       |                                                void*
./sqlite3.cpp: In function ‘void sqlite3SubqueryColumnTypes(Parse*, Table*, Select*, char)’:
./sqlite3.cpp:145277:45: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
145277 |       pCol->zCnName = sqlite3DbReallocOrFree(db, pCol->zCnName, n+k+2);
       |                       ~~~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                             |
       |                                             void*
./sqlite3.cpp: In function ‘Table* sqlite3ResultSetOfSelect(Parse*, Select*, char)’:
./sqlite3.cpp:145309:29: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
145309 |   pTab = sqlite3DbMallocZero(db, sizeof(Table) );
       |          ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~
       |                             |
       |                             void*
./sqlite3.cpp: In function ‘int multiSelectOrderBy(Parse*, Select*, SelectDest*)’:
./sqlite3.cpp:146445:34: warning: invalid conversion from ‘void*’ to ‘u32*’ {aka ‘unsigned int*’} [-fpermissive]
146445 |   aPermute = sqlite3DbMallocRawNN(db, sizeof(u32)*(nOrderBy + 1));
       |              ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                  |
       |                                  void*
./sqlite3.cpp: In function ‘int flattenSubquery(Parse*, Select*, int, int)’:
./sqlite3.cpp:147373:36: warning: invalid conversion from ‘void*’ to ‘int*’ [-fpermissive]
147373 |       aCsrMap = sqlite3DbMallocZero(db, ((i64)pParse->nTab+1)*sizeof(int));
       |                 ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                    |
       |                                    void*
./sqlite3.cpp: In function ‘void constInsert(WhereConst*, Expr*, Expr*, Expr*)’:
./sqlite3.cpp:147701:42: warning: invalid conversion from ‘void*’ to ‘Expr**’ [-fpermissive]
147701 |   pConst->apExpr = sqlite3DbReallocOrFree(pConst->pParse->db, pConst->apExpr,
       |                    ~~~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                          |
       |                                          void*
147702 |                          pConst->nConst*2*sizeof(Expr*));
       |                          ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
./sqlite3.cpp: In function ‘int convertCompoundSelectToSubquery(Walker*, Select*)’:
./sqlite3.cpp:148461:29: warning: invalid conversion from ‘void*’ to ‘Select*’ [-fpermissive]
148461 |   pNew = sqlite3DbMallocZero(db, sizeof(*pNew) );
       |          ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~
       |                             |
       |                             void*
./sqlite3.cpp: In function ‘int resolveFromTermToCte(Parse*, Walker*, SrcItem*)’:
./sqlite3.cpp:148637:31: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
148637 |     pTab = sqlite3DbMallocZero(db, sizeof(Table));
       |            ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~
       |                               |
       |                               void*
./sqlite3.cpp:148641:49: warning: invalid conversion from ‘void*’ to ‘CteUse*’ [-fpermissive]
148641 |       pCte->pUse = pCteUse = sqlite3DbMallocZero(db, sizeof(pCteUse[0]));
       |                              ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~
       |                                                 |
       |                                                 void*
./sqlite3.cpp: In function ‘int sqlite3ExpandSubquery(Parse*, SrcItem*)’:
./sqlite3.cpp:148787:43: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
148787 |   pFrom->pTab = pTab = sqlite3DbMallocZero(pParse->db, sizeof(Table));
       |                        ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                           |
       |                                           void*
./sqlite3.cpp: In function ‘int countOfViewOptimization(Parse*, Select*)’:
./sqlite3.cpp:150061:32: warning: invalid conversion from ‘void*’ to ‘SrcList*’ [-fpermissive]
150061 |   p->pSrc = sqlite3DbMallocZero(pParse->db, sizeof(*p->pSrc));
       |             ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                |
       |                                void*
./sqlite3.cpp: In function ‘int sqlite3Select(Parse*, Select*, SelectDest*)’:
./sqlite3.cpp:150971:35: warning: invalid conversion from ‘void*’ to ‘AggInfo*’ [-fpermissive]
150971 |     pAggInfo = sqlite3DbMallocZero(db, sizeof(*pAggInfo) );
       |                ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~
       |                                   |
       |                                   void*
./sqlite3.cpp: In function ‘int sqlite3_get_table_cb(void*, int, char**, char**)’:
./sqlite3.cpp:151572:27: warning: invalid conversion from ‘void*’ to ‘char**’ [-fpermissive]
151572 |     azNew = sqlite3Realloc( p->azResult, sizeof(char*)*p->nAlloc );
       |             ~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                           |
       |                           void*
./sqlite3.cpp:151604:29: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
151604 |         z = sqlite3_malloc64( n );
       |             ~~~~~~~~~~~~~~~~^~~~~
       |                             |
       |                             void*
./sqlite3.cpp: In function ‘int sqlite3_get_table(sqlite3*, const char*, char***, int*, int*, char**)’:
./sqlite3.cpp:151653:34: warning: invalid conversion from ‘void*’ to ‘char**’ [-fpermissive]
151653 |   res.azResult = sqlite3_malloc64(sizeof(char*)*res.nAlloc );
       |                  ~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                  |
       |                                  void*
./sqlite3.cpp:14013:33: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
14013 | # define SQLITE_INT_TO_PTR(X)  ((void*)(__PTRDIFF_TYPE__)(X))
      |                                ~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      |                                 |
      |                                 void*
./sqlite3.cpp:151661:21: note: in expansion of macro ‘SQLITE_INT_TO_PTR’
151661 |   res.azResult[0] = SQLITE_INT_TO_PTR(res.nData);
       |                     ^~~~~~~~~~~~~~~~~
./sqlite3.cpp:151681:27: warning: invalid conversion from ‘void*’ to ‘char**’ [-fpermissive]
151681 |     azNew = sqlite3Realloc( res.azResult, sizeof(char*)*res.nData );
       |             ~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                           |
       |                           void*
./sqlite3.cpp: In function ‘void sqlite3FinishTrigger(Parse*, TriggerStep*, Token*)’:
./sqlite3.cpp:152112:30: warning: invalid conversion from ‘void*’ to ‘Trigger*’ [-fpermissive]
152112 |     pTrig = sqlite3HashInsert(pHash, zName, pTrig);
       |             ~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~
       |                              |
       |                              void*
./sqlite3.cpp:152117:29: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
152117 |       pTab = sqlite3HashFind(&pLink->pTabSchema->tblHash, pLink->table);
       |              ~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                             |
       |                             void*
./sqlite3.cpp: In function ‘TriggerStep* sqlite3TriggerSelectStep(sqlite3*, Select*, const char*, const char*)’:
./sqlite3.cpp:152154:50: warning: invalid conversion from ‘void*’ to ‘TriggerStep*’ [-fpermissive]
152154 |   TriggerStep *pTriggerStep = sqlite3DbMallocZero(db, sizeof(TriggerStep));
       |                               ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~
       |                                                  |
       |                                                  void*
./sqlite3.cpp: In function ‘TriggerStep* triggerStepAllocate(Parse*, u8, Token*, const char*, const char*)’:
./sqlite3.cpp:152183:37: warning: invalid conversion from ‘void*’ to ‘TriggerStep*’ [-fpermissive]
152183 |   pTriggerStep = sqlite3DbMallocZero(db, sizeof(TriggerStep) + pName->n + 1);
       |                  ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                     |
       |                                     void*
./sqlite3.cpp: In function ‘void sqlite3DropTrigger(Parse*, SrcList*, int)’:
./sqlite3.cpp:152355:31: warning: invalid conversion from ‘void*’ to ‘Trigger*’ [-fpermissive]
152355 |     pTrigger = sqlite3HashFind(&(db->aDb[j].pSchema->trigHash), zName);
       |                ~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                               |
       |                               void*
./sqlite3.cpp: In function ‘Table* tableOfTrigger(Trigger*)’:
./sqlite3.cpp:152378:25: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
152378 |   return sqlite3HashFind(&pTrigger->pTabSchema->tblHash, pTrigger->table);
       |          ~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                         |
       |                         void*
./sqlite3.cpp: In function ‘void sqlite3UnlinkAndDeleteTrigger(sqlite3*, int, const char*)’:
./sqlite3.cpp:152429:31: warning: invalid conversion from ‘void*’ to ‘Trigger*’ [-fpermissive]
152429 |   pTrigger = sqlite3HashInsert(pHash, zName, 0);
       |              ~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~
       |                               |
       |                               void*
./sqlite3.cpp: In function ‘TriggerPrg* codeRowTrigger(Parse*, Trigger*, Table*, int)’:
./sqlite3.cpp:152966:29: warning: invalid conversion from ‘void*’ to ‘TriggerPrg*’ [-fpermissive]
152966 |   pPrg = sqlite3DbMallocZero(db, sizeof(TriggerPrg));
       |          ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~
       |                             |
       |                             void*
./sqlite3.cpp:152970:50: warning: invalid conversion from ‘void*’ to ‘SubProgram*’ [-fpermissive]
152970 |   pPrg->pProgram = pProgram = sqlite3DbMallocZero(db, sizeof(SubProgram));
       |                               ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~
       |                                                  |
       |                                                  void*
./sqlite3.cpp: In function ‘void sqlite3Update(Parse*, SrcList*, ExprList*, Expr*, int, ExprList*, Expr*, Upsert*)’:
./sqlite3.cpp:153716:31: warning: invalid conversion from ‘void*’ to ‘int*’ [-fpermissive]
153716 |   aXRef = sqlite3DbMallocRawNN(db, sizeof(int) * (pTab->nCol+nIdx+1) + nIdx+2 );
       |           ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                               |
       |                               void*
./sqlite3.cpp: In function ‘Upsert* sqlite3UpsertNew(sqlite3*, ExprList*, Expr*, ExprList*, Expr*, Upsert*)’:
./sqlite3.cpp:154710:29: warning: invalid conversion from ‘void*’ to ‘Upsert*’ [-fpermissive]
154710 |   pNew = sqlite3DbMallocZero(db, sizeof(Upsert));
       |          ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~
       |                             |
       |                             void*
./sqlite3.cpp: In function ‘void addModuleArgument(Parse*, Table*, char*)’:
./sqlite3.cpp:155763:33: warning: invalid conversion from ‘void*’ to ‘char**’ [-fpermissive]
155763 |   azModuleArg = sqlite3DbRealloc(db, pTable->u.vtab.azArg, nBytes);
       |                 ~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                 |
       |                                 void*
./sqlite3.cpp: In function ‘void sqlite3VtabFinishParse(Parse*, Token*)’:
./sqlite3.cpp:155910:29: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
155910 |     pOld = sqlite3HashInsert(&pSchema->tblHash, zName, pTab);
       |            ~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                             |
       |                             void*
./sqlite3.cpp: In function ‘int vtabCallConstructor(sqlite3*, Table*, Module*, int (*)(sqlite3*, void*, int, const char* const*, sqlite3_vtab**, char**), char**)’:
./sqlite3.cpp:155985:30: warning: invalid conversion from ‘void*’ to ‘VTable*’ [-fpermissive]
155985 |   pVTable = sqlite3MallocZero(sizeof(VTable));
       |             ~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~
       |                              |
       |                              void*
./sqlite3.cpp:156047:60: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
156047 |         char *zType = sqlite3ColumnType(&pTab->aCol[iCol], "");
       |                                                            ^~
./sqlite3.cpp: In function ‘int growVTrans(sqlite3*)’:
./sqlite3.cpp:156134:31: warning: invalid conversion from ‘void*’ to ‘VTable**’ [-fpermissive]
156134 |     aVTrans = sqlite3DbRealloc(db, (void *)db->aVTrans, nBytes);
       |               ~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                               |
       |                               void*
./sqlite3.cpp: In function ‘FuncDef* sqlite3VtabOverloadFunction(sqlite3*, FuncDef*, int, Expr*)’:
./sqlite3.cpp:156590:29: warning: invalid conversion from ‘void*’ to ‘FuncDef*’ [-fpermissive]
156590 |   pNew = sqlite3DbMallocZero(db, sizeof(*pNew)
       |          ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~
       |                             |
       |                             void*
156591 |                              + sqlite3Strlen30(pDef->zName) + 1);
       |                              ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
./sqlite3.cpp: In function ‘void sqlite3VtabMakeWritable(Parse*, Table*)’:
./sqlite3.cpp:156620:30: warning: invalid conversion from ‘void*’ to ‘Table**’ [-fpermissive]
156620 |   apVtabLock = sqlite3Realloc(pToplevel->apVtabLock, n);
       |                ~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~
       |                              |
       |                              void*
./sqlite3.cpp: In function ‘int sqlite3VtabEponymousTableInit(Parse*, Module*)’:
./sqlite3.cpp:156652:29: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
156652 |   pTab = sqlite3DbMallocZero(db, sizeof(Table));
       |          ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~
       |                             |
       |                             void*
./sqlite3.cpp: In function ‘int codeEqualityTerm(Parse*, WhereTerm*, WhereLevel*, int, int, int)’:
./sqlite3.cpp:158094:27: warning: invalid conversion from ‘void*’ to ‘InLoop*’ [-fpermissive]
158094 |        sqlite3WhereRealloc(pTerm->pWC->pWInfo,
       |        ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~
       |                           |
       |                           void*
158095 |                            pLevel->u.in.aInLoop,
       |                            ~~~~~~~~~~~~~~~~~~~~~
158096 |                            sizeof(pLevel->u.in.aInLoop[0])*pLevel->u.in.nIn);
       |                            ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
./sqlite3.cpp: In function ‘Bitmask sqlite3WhereCodeOneLoopStart(Parse*, Vdbe*, WhereInfo*, int, WhereLevel*, Bitmask)’:
./sqlite3.cpp:159615:36: warning: invalid conversion from ‘void*’ to ‘SrcList*’ [-fpermissive]
159615 |       pOrTab = sqlite3DbMallocRawNN(db,
       |                ~~~~~~~~~~~~~~~~~~~~^~~~
       |                                    |
       |                                    void*
159616 |                             sizeof(*pOrTab)+ nNotReady*sizeof(pOrTab->a[0]));
       |                             ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
./sqlite3.cpp: In function ‘int whereClauseInsert(WhereClause*, Expr*, u16)’:
./sqlite3.cpp:160311:32: warning: invalid conversion from ‘void*’ to ‘WhereTerm*’ [-fpermissive]
160311 |     pWC->a = sqlite3WhereMalloc(pWC->pWInfo, sizeof(pWC->a[0])*pWC->nSlot*2 );
       |              ~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                |
       |                                void*
./sqlite3.cpp: In function ‘void exprAnalyzeOrTerm(SrcList*, WhereClause*, int)’:
./sqlite3.cpp:160907:51: warning: invalid conversion from ‘void*’ to ‘WhereOrInfo*’ [-fpermissive]
160907 |   pTerm->u.pOrInfo = pOrInfo = sqlite3DbMallocZero(db, sizeof(*pOrInfo));
       |                                ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~
       |                                                   |
       |                                                   void*
./sqlite3.cpp:160928:38: warning: invalid conversion from ‘void*’ to ‘WhereAndInfo*’ [-fpermissive]
160928 |       pAndInfo = sqlite3DbMallocRawNN(db, sizeof(*pAndInfo));
       |                  ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~
       |                                      |
       |                                      void*
./sqlite3.cpp: In function ‘void exprAnalyze(SrcList*, WhereClause*, int)’:
./sqlite3.cpp:161459:25: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
161459 |       pExpr->u.zToken = "false";
       |                         ^~~~~~~
./sqlite3.cpp: In function ‘void* sqlite3WhereMalloc(WhereInfo*, u64)’:
./sqlite3.cpp:162380:32: warning: invalid conversion from ‘void*’ to ‘WhereMemBlock*’ [-fpermissive]
162380 |   pBlock = sqlite3DbMallocRawNN(pWInfo->pParse->db, nByte+sizeof(*pBlock));
       |            ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                |
       |                                void*
./sqlite3.cpp: In function ‘void constructAutomaticIndex(Parse*, WhereClause*, Bitmask, WhereLevel*)’:
./sqlite3.cpp:163169:17: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
163169 |   pIdx->zName = "auto-index";
       |                 ^~~~~~~~~~~~
./sqlite3.cpp: In function ‘sqlite3_index_info* allocateIndexInfo(WhereInfo*, WhereClause*, Bitmask, SrcItem*, u16*)’:
./sqlite3.cpp:163549:33: warning: invalid conversion from ‘void*’ to ‘sqlite3_index_info*’ [-fpermissive]
163549 |   pIdxInfo = sqlite3DbMallocZero(pParse->db, sizeof(*pIdxInfo)
       |              ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                 |
       |                                 void*
163550 |                            + (sizeof(*pIdxCons) + sizeof(*pUsage))*nTerm
       |                            ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
163551 |                            + sizeof(*pIdxOrderBy)*nOrderBy + sizeof(*pHidden)
       |                            ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
163552 |                            + sizeof(sqlite3_value*)*nTerm );
       |                            ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
./sqlite3.cpp: In function ‘int whereLoopResize(sqlite3*, WhereLoop*, int)’:
./sqlite3.cpp:164545:31: warning: invalid conversion from ‘void*’ to ‘WhereTerm**’ [-fpermissive]
164545 |   paNew = sqlite3DbMallocRawNN(db, sizeof(p->aLTerm[0])*n);
       |           ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                               |
       |                               void*
./sqlite3.cpp: In function ‘int whereLoopInsert(WhereLoopBuilder*, WhereLoop*)’:
./sqlite3.cpp:164877:39: warning: invalid conversion from ‘void*’ to ‘WhereLoop*’ [-fpermissive]
164877 |     *ppPrev = p = sqlite3DbMallocRawNN(db, sizeof(WhereLoop));
       |                   ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~
       |                                       |
       |                                       void*
./sqlite3.cpp: In function ‘int wherePathSolver(WhereInfo*, LogEst)’:
./sqlite3.cpp:20644:58: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
20644 | # define sqlite3StackAllocRawNN(D,N) sqlite3DbMallocRawNN(D,N)
      |                                      ~~~~~~~~~~~~~~~~~~~~^~~~~
      |                                                          |
      |                                                          void*
./sqlite3.cpp:167387:12: note: in expansion of macro ‘sqlite3StackAllocRawNN’
167387 |   pSpace = sqlite3StackAllocRawNN(pParse->db, nSpace);
       |            ^~~~~~~~~~~~~~~~~~~~~~
./sqlite3.cpp: In function ‘void whereAddIndexedExpr(Parse*, Index*, int, SrcItem*)’:
./sqlite3.cpp:168203:27: warning: invalid conversion from ‘void*’ to ‘IndexedExpr*’ [-fpermissive]
168203 |     p = sqlite3DbMallocRaw(pParse->db,  sizeof(IndexedExpr));
       |         ~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                           |
       |                           void*
./sqlite3.cpp: In function ‘WhereInfo* sqlite3WhereBegin(Parse*, SrcList*, Expr*, ExprList*, ExprList*, Select*, u16, int)’:
./sqlite3.cpp:168413:32: warning: invalid conversion from ‘void*’ to ‘WhereInfo*’ [-fpermissive]
168413 |   pWInfo = sqlite3DbMallocRawNN(db, nByteWInfo + sizeof(WhereLoop));
       |            ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                |
       |                                void*
./sqlite3.cpp:14013:33: warning: invalid conversion from ‘void*’ to ‘const char*’ [-fpermissive]
14013 | # define SQLITE_INT_TO_PTR(X)  ((void*)(__PTRDIFF_TYPE__)(X))
      |                                ~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      |                                 |
      |                                 void*
./sqlite3.cpp:168800:36: note: in expansion of macro ‘SQLITE_INT_TO_PTR’
168800 |         sqlite3VdbeChangeP4(v, -1, SQLITE_INT_TO_PTR(n), P4_INT32);
       |                                    ^~~~~~~~~~~~~~~~~
./sqlite3.cpp:86383:72: note:   initializing argument 3 of ‘void sqlite3VdbeChangeP4(Vdbe*, int, const char*, int)’
86383 | SQLITE_PRIVATE void sqlite3VdbeChangeP4(Vdbe *p, int addr, const char *zP4, int n){
      |                                                            ~~~~~~~~~~~~^~~
./sqlite3.cpp:168891:42: warning: invalid conversion from ‘void*’ to ‘WhereRightJoin*’ [-fpermissive]
168891 |      && (pLevel->pRJ = sqlite3WhereMalloc(pWInfo, sizeof(WhereRightJoin)))!=0
       |                        ~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                          |
       |                                          void*
./sqlite3.cpp: In function ‘int sqlite3WindowRewrite(Parse*, Select*)’:
./sqlite3.cpp:170351:31: warning: invalid conversion from ‘void*’ to ‘Table*’ [-fpermissive]
170351 |     pTab = sqlite3DbMallocZero(db, sizeof(Table));
       |            ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~
       |                               |
       |                               void*
./sqlite3.cpp: In function ‘Window* sqlite3WindowDup(sqlite3*, Expr*, Window*)’:
./sqlite3.cpp:171750:31: warning: invalid conversion from ‘void*’ to ‘Window*’ [-fpermissive]
171750 |     pNew = sqlite3DbMallocZero(db, sizeof(Window));
       |            ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~
       |                               |
       |                               void*
./sqlite3.cpp: In function ‘Expr* tokenExpr(Parse*, int, Token)’:
./sqlite3.cpp:172639:35: warning: invalid conversion from ‘void*’ to ‘Expr*’ [-fpermissive]
172639 |     Expr *p = sqlite3DbMallocRawNN(pParse->db, sizeof(Expr)+t.n+1);
       |               ~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                   |
       |                                   void*
./sqlite3.cpp: In function ‘int yyGrowStack(yyParser*)’:
./sqlite3.cpp:174769:21: warning: invalid conversion from ‘void*’ to ‘yyStackEntry*’ [-fpermissive]
174769 |     pNew = YYREALLOC(0, newSize*sizeof(pNew[0]));
       |                     ^
       |                     |
       |                     void*
./sqlite3.cpp:174773:21: warning: invalid conversion from ‘void*’ to ‘yyStackEntry*’ [-fpermissive]
174773 |     pNew = YYREALLOC(p->yystack, newSize*sizeof(pNew[0]));
       |                     ^
       |                     |
       |                     void*
./sqlite3.cpp: In function ‘int sqlite3_complete16(const void*)’:
./sqlite3.cpp:179670:27: warning: invalid conversion from ‘const void*’ to ‘const char*’ [-fpermissive]
179670 |   zSql8 = sqlite3ValueText(pVal, SQLITE_UTF8);
       |           ~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~
       |                           |
       |                           const void*
./sqlite3.cpp: In function ‘void sqlite3LeaveMutexAndCloseZombie(sqlite3*)’:
./sqlite3.cpp:14460:35: warning: invalid conversion from ‘void*’ to ‘FuncDef*’ [-fpermissive]
14460 | #define sqliteHashData(E)   ((E)->data)
      |                             ~~~~~~^~~~~
      |                                   |
      |                                   void*
./sqlite3.cpp:181204:9: note: in expansion of macro ‘sqliteHashData’
181204 |     p = sqliteHashData(i);
       |         ^~~~~~~~~~~~~~
./sqlite3.cpp: In function ‘int createCollation(sqlite3*, const char*, u8, void*, int (*)(void*, int, const void*, int, const void*), void (*)(void*))’:
./sqlite3.cpp:182610:39: warning: invalid conversion from ‘void*’ to ‘CollSeq*’ [-fpermissive]
182610 |       CollSeq *aColl = sqlite3HashFind(&db->aCollSeq, zName);
       |                        ~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~
       |                                       |
       |                                       void*
./sqlite3.cpp: In function ‘int sqlite3ParseUri(const char*, const char*, unsigned int*, sqlite3_vfs**, char**, char**)’:
./sqlite3.cpp:182807:29: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
182807 |     zFile = sqlite3_malloc64(nByte);
       |             ~~~~~~~~~~~~~~~~^~~~~~~
       |                             |
       |                             void*
./sqlite3.cpp:182935:23: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
182935 |           zModeType = "cache";
       |                       ^~~~~~~
./sqlite3.cpp:182950:23: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
182950 |           zModeType = "access";
       |                       ^~~~~~~~
./sqlite3.cpp:182982:29: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
182982 |     zFile = sqlite3_malloc64(nUri+8);
       |             ~~~~~~~~~~~~~~~~^~~~~~~~
       |                             |
       |                             void*
./sqlite3.cpp: In function ‘int openDatabase(const char*, sqlite3**, unsigned int, const char*)’:
./sqlite3.cpp:183092:25: warning: invalid conversion from ‘void*’ to ‘sqlite3*’ [-fpermissive]
183092 |   db = sqlite3MallocZero( sizeof(sqlite3) );
       |        ~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~
       |                         |
       |                         void*
./sqlite3.cpp:183297:25: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
183297 |   db->aDb[0].zDbSName = "main";
       |                         ^~~~~~
./sqlite3.cpp:183299:25: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
183299 |   db->aDb[1].zDbSName = "temp";
       |                         ^~~~~~
./sqlite3.cpp: In function ‘int sqlite3_open16(const void*, sqlite3**)’:
./sqlite3.cpp:183426:32: warning: invalid conversion from ‘const void*’ to ‘const char*’ [-fpermissive]
183426 |   zFilename8 = sqlite3ValueText(pVal, SQLITE_UTF8);
       |                ~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~
       |                                |
       |                                const void*
./sqlite3.cpp: In function ‘int sqlite3_set_clientdata(sqlite3*, const char*, void*, void (*)(void*))’:
./sqlite3.cpp:183598:25: warning: invalid conversion from ‘void*’ to ‘DbClientData*’ [-fpermissive]
183598 |     p = sqlite3_malloc64( sizeof(DbClientData)+n+1 );
       |         ~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                         |
       |                         void*
./sqlite3.cpp: In function ‘const char* sqlite3_create_filename(const char*, const char*, const char*, int, const char**)’:
./sqlite3.cpp:184528:33: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
184528 |   pResult = p = sqlite3_malloc64( nByte );
       |                 ~~~~~~~~~~~~~~~~^~~~~~~~~
       |                                 |
       |                                 void*
./sqlite3.cpp: In function ‘int jsonCacheInsert(sqlite3_context*, JsonParse*)’:
./sqlite3.cpp:205265:26: warning: invalid conversion from ‘void*’ to ‘JsonCache*’ [-fpermissive]
205265 |   p = sqlite3_get_auxdata(ctx, JSON_CACHE_ID);
       |       ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~
       |                          |
       |                          void*
./sqlite3.cpp:205268:28: warning: invalid conversion from ‘void*’ to ‘JsonCache*’ [-fpermissive]
205268 |     p = sqlite3DbMallocZero(db, sizeof(*p));
       |         ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~
       |                            |
       |                            void*
./sqlite3.cpp:205272:28: warning: invalid conversion from ‘void*’ to ‘JsonCache*’ [-fpermissive]
205272 |     p = sqlite3_get_auxdata(ctx, JSON_CACHE_ID);
       |         ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~
       |                            |
       |                            void*
./sqlite3.cpp: In function ‘JsonParse* jsonCacheSearch(sqlite3_context*, sqlite3_value*)’:
./sqlite3.cpp:205316:26: warning: invalid conversion from ‘void*’ to ‘JsonCache*’ [-fpermissive]
205316 |   p = sqlite3_get_auxdata(ctx, JSON_CACHE_ID);
       |       ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~
       |                          |
       |                          void*
./sqlite3.cpp: At global scope:
./sqlite3.cpp:205931:34: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
205931 |   { 'i', 'I', 3, JSONB_FLOAT, 7, "inf", "9.0e999" },
       |                                  ^~~~~
./sqlite3.cpp:205931:41: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
205931 |   { 'i', 'I', 3, JSONB_FLOAT, 7, "inf", "9.0e999" },
       |                                         ^~~~~~~~~
./sqlite3.cpp:205932:34: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
205932 |   { 'i', 'I', 8, JSONB_FLOAT, 7, "infinity", "9.0e999" },
       |                                  ^~~~~~~~~~
./sqlite3.cpp:205932:46: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
205932 |   { 'i', 'I', 8, JSONB_FLOAT, 7, "infinity", "9.0e999" },
       |                                              ^~~~~~~~~
./sqlite3.cpp:205933:33: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
205933 |   { 'n', 'N', 3, JSONB_NULL, 4, "NaN", "null" },
       |                                 ^~~~~
./sqlite3.cpp:205933:40: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
205933 |   { 'n', 'N', 3, JSONB_NULL, 4, "NaN", "null" },
       |                                        ^~~~~~
./sqlite3.cpp:205934:33: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
205934 |   { 'q', 'Q', 4, JSONB_NULL, 4, "QNaN", "null" },
       |                                 ^~~~~~
./sqlite3.cpp:205934:41: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
205934 |   { 'q', 'Q', 4, JSONB_NULL, 4, "QNaN", "null" },
       |                                         ^~~~~~
./sqlite3.cpp:205935:33: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
205935 |   { 's', 'S', 4, JSONB_NULL, 4, "SNaN", "null" },
       |                                 ^~~~~~
./sqlite3.cpp:205935:41: warning: ISO C++ forbids converting a string constant to ‘char*’ [-Wwrite-strings]
205935 |   { 's', 'S', 4, JSONB_NULL, 4, "SNaN", "null" },
       |                                         ^~~~~~
./sqlite3.cpp: In function ‘int jsonBlobExpand(JsonParse*, u32)’:
./sqlite3.cpp:205972:26: warning: invalid conversion from ‘void*’ to ‘u8*’ {aka ‘unsigned char*’} [-fpermissive]
205972 |   aNew = sqlite3DbRealloc(pParse->db, pParse->aBlob, t);
       |          ~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                          |
       |                          void*
./sqlite3.cpp: In function ‘int jsonFuncArgMightBeBinary(sqlite3_value*)’:
./sqlite3.cpp:207331:29: warning: invalid conversion from ‘const void*’ to ‘const u8*’ {aka ‘const unsigned char*’} [-fpermissive]
207331 |   aBlob = sqlite3_value_blob(pJson);
       |           ~~~~~~~~~~~~~~~~~~^~~~~~~
       |                             |
       |                             const void*
./sqlite3.cpp: In function ‘void jsonReturnFromBlob(JsonParse*, u32, sqlite3_context*, int)’:
./sqlite3.cpp:207992:32: warning: invalid conversion from ‘void*’ to ‘char*’ [-fpermissive]
207992 |       zOut = sqlite3DbMallocRaw(db, nOut+1);
       |              ~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~
       |                                |
       |                                void*
./sqlite3.cpp: In function ‘JsonParse* jsonParseFuncArg(sqlite3_context*, sqlite3_value*, u32)’:
./sqlite3.cpp:208310:26: warning: invalid conversion from ‘void*’ to ‘JsonParse*’ [-fpermissive]
208310 |   p = sqlite3DbMallocZero(db, sizeof(*p));
       |       ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~
       |                          |
       |                          void*
./sqlite3.cpp:208317:34: warning: invalid conversion from ‘void*’ to ‘u8*’ {aka ‘unsigned char*’} [-fpermissive]
208317 |     p->aBlob = sqlite3DbMallocRaw(db, nBlob);
       |                ~~~~~~~~~~~~~~~~~~^~~~~~~~~~~
       |                                  |
       |                                  void*
./sqlite3.cpp: In function ‘int jsonEachOpenEach(sqlite3_vtab*, sqlite3_vtab_cursor**)’:
./sqlite3.cpp:209738:29: warning: invalid conversion from ‘void*’ to ‘JsonEachCursor*’ [-fpermissive]
209738 |   pCur = sqlite3DbMallocZero(pVtab->db, sizeof(*pCur));
       |          ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~
       |                             |
       |                             void*
./sqlite3.cpp: In function ‘int jsonEachNext(sqlite3_vtab_cursor*)’:
./sqlite3.cpp:209852:32: warning: invalid conversion from ‘void*’ to ‘JsonParent*’ [-fpermissive]
209852 |         pNew = sqlite3DbRealloc(p->db, p->aParent, sizeof(JsonParent)*nNew);
       |                ~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                |
       |                                void*
./sqlite3.cpp: In function ‘int jsonEachFilter(sqlite3_vtab_cursor*, int, const char*, int, sqlite3_value**)’:
./sqlite3.cpp:210179:37: warning: invalid conversion from ‘void*’ to ‘JsonParent*’ [-fpermissive]
210179 |     p->aParent = sqlite3DbMallocZero(p->db, sizeof(JsonParent));
       |                  ~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~~~~~~~~~~~~~~~~
       |                                     |
       |                                     void*
==21624==
==21624== HEAP SUMMARY:
==21624==     in use at exit: 7,045,865 bytes in 15,051 blocks
==21624==   total heap usage: 490,444 allocs, 475,393 frees, 649,209,160 bytes allocated
==21624==
==21624== LEAK SUMMARY:
==21624==    definitely lost: 6 bytes in 1 blocks
==21624==    indirectly lost: 0 bytes in 0 blocks
==21624==      possibly lost: 343,320 bytes in 42 blocks
==21624==    still reachable: 6,702,539 bytes in 15,008 blocks
==21624==         suppressed: 0 bytes in 0 blocks
==21624== Rerun with --leak-check=full to see details of leaked memory
==21624==
==21624== For lists of detected and suppressed errors, rerun with: -s
==21624== ERROR SUMMARY: 0 errors from 0 contexts (suppressed: 0 from 0)
==21623==
==21623== HEAP SUMMARY:
==21623==     in use at exit: 189,449 bytes in 69 blocks
==21623==   total heap usage: 234 allocs, 165 frees, 215,031 bytes allocated
==21623==
==21623== LEAK SUMMARY:
==21623==    definitely lost: 5,291 bytes in 18 blocks
==21623==    indirectly lost: 8,464 bytes in 3 blocks
==21623==      possibly lost: 0 bytes in 0 blocks
==21623==    still reachable: 175,694 bytes in 48 blocks
==21623==         suppressed: 0 bytes in 0 blocks
==21623== Rerun with --leak-check=full to see details of leaked memory
==21623==
==21623== For lists of detected and suppressed errors, rerun with: -s
==21623== ERROR SUMMARY: 0 errors from 0 contexts (suppressed: 0 from 0)
40.27user 0.34system 0:40.63elapsed 99%CPU (0avgtext+0avgdata 337688maxresident)k
4416inputs+0outputs (1major+147633minor)pagefaults 0swaps
